﻿unit mainWin;

interface

{$WARN SYMBOL_PLATFORM OFF}

uses
  Windows, Types, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TextEditor, ActnList, ComCtrls, TabControl, Menus, ExtCtrls, StdCtrls,
  ZoomControl, TextEncodings, AppEvnts, BitmapEffects, System.Actions, ActiveX,
  System.Win.ComObj;

const
  REJBRAND_MUTEX_RTE_RTEDITOR = 'Rejbrand Text Editor';
  RTE_WNDCLASS_NAME = 'TRejbrandTextEditor';
  FILE_SIZE_LIMIT = 500 * 1024 * 1024;
  WM_QUERYPREVINST = WM_APP + 1;
  PREVINST_NOTAVAIL = 0;
  PREVINST_READY = 1;
  RTE_COPYDATA_FILEARRAY = NativeUInt($1000);
  RTE_COPYDATA_TEXTFILE = NativeUInt($2000);
  RTE_COPYDATA_FLAG_MASK = NativeUInt($FF);
  RTE_COPYDATA_FLAG_CLOSEDUMMY = NativeUInt(1);

type
  TTaskDialogHelper = class helper for TTaskDialog
    function ExecuteModally: boolean;
  end;

  TRejbrandTextEditor = class(TForm, IDropTarget)
    ActionList: TActionList;
    aNew: TAction;
    Editor: TTextEditor;
    TabList: TSimpleTabControl;
    aOpen: TAction;
    aSave: TAction;
    aSaveAs: TAction;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    aClose: TAction;
    Close1: TMenuItem;
    aExit: TAction;
    N2: TMenuItem;
    Exit1: TMenuItem;
    aRevert: TAction;
    Revert1: TMenuItem;
    aDeleteFile: TAction;
    Deletefile1: TMenuItem;
    aShellExecuteFile: TAction;
    Shellrunfile1: TMenuItem;
    aOpenFolder: TAction;
    Openfolder1: TMenuItem;
    aPrint: TAction;
    N3: TMenuItem;
    Print1: TMenuItem;
    aHTMLExport: TAction;
    ExporttoHTML1: TMenuItem;
    aPrinterSetup: TAction;
    Printersetup1: TMenuItem;
    Edit1: TMenuItem;
    aUndo: TAction;
    aRedo: TAction;
    Undo1: TMenuItem;
    Redo1: TMenuItem;
    N4: TMenuItem;
    aCut: TAction;
    aCopy: TAction;
    aPaste: TAction;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    aClear: TAction;
    Clear1: TMenuItem;
    N5: TMenuItem;
    aSelectAll: TAction;
    aSelectAll1: TMenuItem;
    aSelectWord: TAction;
    Selectword1: TMenuItem;
    aSelectLine: TAction;
    Selectline1: TMenuItem;
    N6: TMenuItem;
    aClearLine: TAction;
    Clearline1: TMenuItem;
    aPerformWordWrap: TAction;
    Performwordwrap1: TMenuItem;
    aSortLines: TAction;
    Sortlines1: TMenuItem;
    N7: TMenuItem;
    aAddIndent: TAction;
    aRemoveIndent: TAction;
    aRemoveAllIndent: TAction;
    Increaseindent1: TMenuItem;
    Removeallindent1: TMenuItem;
    Removeallindent2: TMenuItem;
    aTrimRight: TAction;
    rimright1: TMenuItem;
    aUpperCase: TAction;
    aLowerCase: TAction;
    aInvertCase: TAction;
    aSentenceCase: TAction;
    aCamelCase: TAction;
    N8: TMenuItem;
    Charactercase1: TMenuItem;
    ouppercase1: TMenuItem;
    olowercase1: TMenuItem;
    Invertcase1: TMenuItem;
    osentencecase1: TMenuItem;
    ocamelcase1: TMenuItem;
    aROT13: TAction;
    aCaesar: TAction;
    aVigenereEncrypt: TAction;
    aVigenereDecrypt: TAction;
    Encryption1: TMenuItem;
    PerformROT131: TMenuItem;
    Caesarcipher1: TMenuItem;
    Vigenreencrypt1: TMenuItem;
    Vigenredecrypt1: TMenuItem;
    aHistory: TAction;
    History1: TMenuItem;
    pnSearch: TPanel;
    StaticText1: TStaticText;
    eFind: TEdit;
    cbFindMatchCase: TCheckBox;
    cbFindWholeWords: TCheckBox;
    cbFindNewline: TCheckBox;
    btnFindPrev: TButton;
    btnFindNext: TButton;
    aFind: TAction;
    Find1: TMenuItem;
    Find2: TMenuItem;
    stNumMatches: TStaticText;
    aFindNext: TAction;
    aFindPrev: TAction;
    Previous1: TMenuItem;
    Next1: TMenuItem;
    aReplace: TAction;
    Redo2: TMenuItem;
    N9: TMenuItem;
    aGoTo: TAction;
    N10: TMenuItem;
    Goto1: TMenuItem;
    aStatusBar: TAction;
    StatusBar: TStatusBar;
    View1: TMenuItem;
    Statusbar1: TMenuItem;
    aRuler: TAction;
    Ruler1: TMenuItem;
    aToggleFocus: TAction;
    aDateTime: TAction;
    Insert1: TMenuItem;
    Insertdateandtime1: TMenuItem;
    aCustomDateTime: TAction;
    Customdateortime1: TMenuItem;
    TabPopup: TPopupMenu;
    Save2: TMenuItem;
    Saveas2: TMenuItem;
    Deletefile2: TMenuItem;
    Shellrunfile2: TMenuItem;
    Openfolder2: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    Close2: TMenuItem;
    aInsertChar: TAction;
    Character1: TMenuItem;
    ZoomControl: TZoomControl;
    StatusMessagePopup: TPopupMenu;
    StatusPosPopup: TPopupMenu;
    Goto2: TMenuItem;
    aMakeUnique: TAction;
    Makelinesunique1: TMenuItem;
    aNextTab: TAction;
    aPrevTab: TAction;
    TabListPopup: TPopupMenu;
    Previoustab1: TMenuItem;
    Nexttab1: TMenuItem;
    N11: TMenuItem;
    New2: TMenuItem;
    N14: TMenuItem;
    aHTMLH1: TAction;
    aHTMLH2: TAction;
    aHTMLH3: TAction;
    aHTMLH4: TAction;
    aHTMLH5: TAction;
    aHTMLH6: TAction;
    aHTMLP: TAction;
    aHTMLDiv: TAction;
    aHTMLBr: TAction;
    aHTMLUL: TAction;
    aHTMLOL: TAction;
    aHTMLLI: TAction;
    aHTMLnbsp: TAction;
    aHTMLB: TAction;
    aHTMLI: TAction;
    aHTMLEM: TAction;
    aHTMLstrong: TAction;
    aHTMLU: TAction;
    aHTMLspan: TAction;
    N15: TMenuItem;
    XHTML1: TMenuItem;
    Headings1: TMenuItem;
    Heading11: TMenuItem;
    Heading21: TMenuItem;
    Heading31: TMenuItem;
    Heading41: TMenuItem;
    Heading51: TMenuItem;
    Heading61: TMenuItem;
    Paragraph1: TMenuItem;
    Division1: TMenuItem;
    N16: TMenuItem;
    Nonbreakingspace1: TMenuItem;
    aHTMLBr1: TMenuItem;
    N17: TMenuItem;
    aHTMLUL1: TMenuItem;
    aHTMLOL1: TMenuItem;
    aHTMLLI1: TMenuItem;
    N18: TMenuItem;
    Bold1: TMenuItem;
    Italic1: TMenuItem;
    Emphasis1: TMenuItem;
    Strongemphasis1: TMenuItem;
    Underline1: TMenuItem;
    Span1: TMenuItem;
    N19: TMenuItem;
    aHTMLtable: TAction;
    aHTMLtr: TAction;
    aHTMLth: TAction;
    aHTMLtd: TAction;
    able1: TMenuItem;
    ablerow1: TMenuItem;
    ableheadingcell1: TMenuItem;
    abledatacell1: TMenuItem;
    aFont: TAction;
    Options1: TMenuItem;
    Font1: TMenuItem;
    aPasteAs: TAction;
    Pasteas1: TMenuItem;
    aInsertColor: TAction;
    N20: TMenuItem;
    Colourcode1: TMenuItem;
    aSetBgColor: TAction;
    Colours1: TMenuItem;
    Setbackgroundcolour1: TMenuItem;
    aSetRowHighlightColor: TAction;
    Setlinehighlightcolour1: TMenuItem;
    aSetSelBgColor: TAction;
    Setselectionbackgroundcolour1: TMenuItem;
    aSetSelFgColor: TAction;
    Setselectiontextcolour1: TMenuItem;
    aSetSearchHighlightColor: TAction;
    Setsearchhighlightcolour1: TMenuItem;
    aSetSearchHighlightTextColor: TAction;
    Setsearchhighlighttextcolour1: TMenuItem;
    aSetBracketHighlightColor: TAction;
    Setbrackethighlightcolour1: TMenuItem;
    aSetTextColor: TAction;
    Settextcolour1: TMenuItem;
    aSetRulerBackgroundColor: TAction;
    Setrulerbackgroundcolour1: TMenuItem;
    aSetRulerTextColor: TAction;
    Setrulertextcolour1: TMenuItem;
    N21: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    aUseSystemDefaultColors: TAction;
    N24: TMenuItem;
    Usesystemdefaultcolours1: TMenuItem;
    XMLFormattingProcessor1: TXMLFormattingProcessor;
    CSSFormattingProcessor1: TCSSFormattingProcessor;
    INIFormattingProcessor1: TINIFormattingProcessor;
    PascalFormattingProcessor1: TPascalFormattingProcessor;
    AlgoSimFormattingProcessor1: TAlgoSimFormattingProcessor;
    HTMLFormattingProcessor1: THTMLFormattingProcessor;
    MediaWikiFormattingProcessor1: TMediaWikiFormattingProcessor;
    aFPXML: TAction;
    aFPHTML: TAction;
    aFPCSS: TAction;
    aFPMW: TAction;
    aFPINI: TAction;
    aFPPascal: TAction;
    aFPAS: TAction;
    Syntaxhighlighting1: TMenuItem;
    XML1: TMenuItem;
    HTMLwithCSSsupport1: TMenuItem;
    CSS1: TMenuItem;
    MediaWiki1: TMenuItem;
    ObjectPascalDelphi1: TMenuItem;
    AlgoSim1: TMenuItem;
    INI1: TMenuItem;
    aFPNone: TAction;
    N25: TMenuItem;
    None1: TMenuItem;
    N26: TMenuItem;
    aRowHighlight: TAction;
    aBracketHighlight: TAction;
    Linehighlight1: TMenuItem;
    Brackethighlight1: TMenuItem;
    aHiddenChars: TAction;
    Showhiddencharacters1: TMenuItem;
    aCaretBeyondEOL: TAction;
    N27: TMenuItem;
    CaretbeyondEOL1: TMenuItem;
    aAutoIndent: TAction;
    Autoindent1: TMenuItem;
    aAutoReplace: TAction;
    Autoreplace1: TMenuItem;
    aSetTabLength: TAction;
    Settablength1: TMenuItem;
    N28: TMenuItem;
    aReadOnly: TAction;
    Readonly1: TMenuItem;
    aRestoreSettings: TAction;
    N29: TMenuItem;
    Restoredefaultsettings1: TMenuItem;
    aSettings: TAction;
    Settablength2: TMenuItem;
    aEncUTF8: TAction;
    aEncASCII: TAction;
    aEncUTF16LE: TAction;
    mnuEncoding: TMenuItem;
    ASCII1: TMenuItem;
    UTF81: TMenuItem;
    UTF16LE1: TMenuItem;
    aEncUTF16BE: TAction;
    UTF16BE1: TMenuItem;
    aEncANSI: TAction;
    aEncUTF32LE: TAction;
    aEncUTF32BE: TAction;
    N8bitextendedASCII1: TMenuItem;
    UTF32LE1: TMenuItem;
    UTF32BE1: TMenuItem;
    N30: TMenuItem;
    aEncMagicBytes: TAction;
    N31: TMenuItem;
    MagicbytesBOM1: TMenuItem;
    aEncCRLF: TAction;
    aEncLF: TAction;
    N32: TMenuItem;
    CarriagereturnCFlinefeedLF1: TMenuItem;
    LinefeedLF1: TMenuItem;
    mnuTabs: TMenuItem;
    Previoustab2: TMenuItem;
    Nexttab2: TMenuItem;
    N33: TMenuItem;
    aFillWithchar: TAction;
    Fillwithcharacter1: TMenuItem;
    aBlockPaste: TAction;
    Blockpaste1: TMenuItem;
    aStatistics: TAction;
    ools1: TMenuItem;
    Statistics1: TMenuItem;
    aTruncateAt: TAction;
    runcateat1: TMenuItem;
    aAbout: TAction;
    Help1: TMenuItem;
    About1: TMenuItem;
    aTipOfTheDay: TAction;
    ipoftheday1: TMenuItem;
    N34: TMenuItem;
    aSetFPAssoc: TAction;
    N35: TMenuItem;
    Setassociations1: TMenuItem;
    ApplicationEvents: TApplicationEvents;
    aHelp: TAction;
    Keyboardcommandsandotherreference1: TMenuItem;
    aFilter: TAction;
    Filterlines1: TMenuItem;
    aDuplicateBuffer: TAction;
    aSelectionToNewBuffer: TAction;
    Duplicatebuffer2: TMenuItem;
    aSaveAll: TAction;
    Saveall1: TMenuItem;
    N37: TMenuItem;
    aCloseAll: TAction;
    Closeall1: TMenuItem;
    aCloseAllWithoutSave: TAction;
    Closeallwithoutsaving1: TMenuItem;
    N38: TMenuItem;
    aCheckASCII: TAction;
    N39: TMenuItem;
    CheckiffileisASCIIonly1: TMenuItem;
    aLoremIpsum: TAction;
    Loremipsum1: TMenuItem;
    Saveall2: TMenuItem;
    Closeall2: TMenuItem;
    aStatusMsgCopy: TAction;
    Copystatusbarmessagetoclipboard1: TMenuItem;
    aShowAutoReplaceList: TAction;
    aShowAutoReplaceList1: TMenuItem;
    aNotificationWindow: TAction;
    N36: TMenuItem;
    Duplicatebuffer1: TMenuItem;
    Newbufferfromselection1: TMenuItem;
    aAdvStatistics: TAction;
    Advancedstatistics1: TMenuItem;
    aChrFind: TAction;
    Charactersearch1: TMenuItem;
    N40: TMenuItem;
    N41: TMenuItem;
    OntheWWW1: TMenuItem;
    mnuURLARH: TMenuItem;
    mnuURLRTE: TMenuItem;
    mnuURLRTEdoc: TMenuItem;
    aItUpperCase: TAction;
    aItLowerCase: TAction;
    aItSuperscript: TAction;
    aItSubscript: TAction;
    aItParenthesized: TAction;
    aItCircled: TAction;
    aItDoublyCircled: TAction;
    aItNone: TAction;
    N42: TMenuItem;
    Inputtransforms1: TMenuItem;
    None2: TMenuItem;
    Uppercase1: TMenuItem;
    Lowercase1: TMenuItem;
    Superscript1: TMenuItem;
    Subscript1: TMenuItem;
    Parenthesized1: TMenuItem;
    Encircled1: TMenuItem;
    Doublyencircled1: TMenuItem;
    N43: TMenuItem;
    aInsertCharByDescriptionSearch: TAction;
    aReverseText: TAction;
    Reversetext1: TMenuItem;
    aFindCurrentSymbol: TAction;
    Findcurrentsymbol1: TMenuItem;
    aFindCurrentSymbolPascal: TAction;
    aCopyFileName: TAction;
    Copyfilename1: TMenuItem;
    aNewWindow: TAction;
    Newwindow1: TMenuItem;
    aDetach: TAction;
    N44: TMenuItem;
    Detach1: TMenuItem;
    aCloseOther: TAction;
    Closeallother1: TMenuItem;
    Closeallother2: TMenuItem;
    aCompare: TAction;
    N45: TMenuItem;
    Comparebuffers1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure aNewExecute(Sender: TObject);
    procedure TabListChange(Sender: TObject);
    procedure aOpenExecute(Sender: TObject);
    procedure aSaveExecute(Sender: TObject);
    procedure aSaveAsExecute(Sender: TObject);
    procedure aCloseExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure aExitExecute(Sender: TObject);
    procedure aRevertExecute(Sender: TObject);
    procedure aRevertUpdate(Sender: TObject);
    procedure aDeleteFileUpdate(Sender: TObject);
    procedure aDeleteFileExecute(Sender: TObject);
    procedure aShellExecuteFileUpdate(Sender: TObject);
    procedure aShellExecuteFileExecute(Sender: TObject);
    procedure aOpenFolderUpdate(Sender: TObject);
    procedure aOpenFolderExecute(Sender: TObject);
    procedure aPrintExecute(Sender: TObject);
    procedure aHTMLExportExecute(Sender: TObject);
    procedure aPrinterSetupExecute(Sender: TObject);
    procedure aUndoUpdate(Sender: TObject);
    procedure aUndoExecute(Sender: TObject);
    procedure aRedoUpdate(Sender: TObject);
    procedure aRedoExecute(Sender: TObject);
    procedure aCutUpdate(Sender: TObject);
    procedure aCutExecute(Sender: TObject);
    procedure aCopyUpdate(Sender: TObject);
    procedure aCopyExecute(Sender: TObject);
    procedure aPasteUpdate(Sender: TObject);
    procedure aPasteExecute(Sender: TObject);
    procedure aClearUpdate(Sender: TObject);
    procedure aClearExecute(Sender: TObject);
    procedure aSelectAllUpdate(Sender: TObject);
    procedure aSelectAllExecute(Sender: TObject);
    procedure aSelectWordExecute(Sender: TObject);
    procedure aSelectWordUpdate(Sender: TObject);
    procedure aSelectLineUpdate(Sender: TObject);
    procedure aSelectLineExecute(Sender: TObject);
    procedure aClearLineUpdate(Sender: TObject);
    procedure aClearLineExecute(Sender: TObject);
    procedure aPerformWordWrapUpdate(Sender: TObject);
    procedure aPerformWordWrapExecute(Sender: TObject);
    procedure aSortLinesUpdate(Sender: TObject);
    procedure aSortLinesExecute(Sender: TObject);
    procedure aAddIndentExecute(Sender: TObject);
    procedure aRemoveIndentExecute(Sender: TObject);
    procedure aRemoveAllIndentExecute(Sender: TObject);
    procedure aTrimRightExecute(Sender: TObject);
    procedure aUpperCaseExecute(Sender: TObject);
    procedure aUpperCaseUpdate(Sender: TObject);
    procedure aLowerCaseUpdate(Sender: TObject);
    procedure aLowerCaseExecute(Sender: TObject);
    procedure aInvertCaseUpdate(Sender: TObject);
    procedure aInvertCaseExecute(Sender: TObject);
    procedure aSentenceCaseUpdate(Sender: TObject);
    procedure aSentenceCaseExecute(Sender: TObject);
    procedure aCamelCaseUpdate(Sender: TObject);
    procedure aCamelCaseExecute(Sender: TObject);
    procedure aROT13Update(Sender: TObject);
    procedure aROT13Execute(Sender: TObject);
    procedure aCaesarUpdate(Sender: TObject);
    procedure aCaesarExecute(Sender: TObject);
    procedure aVigenereEncryptUpdate(Sender: TObject);
    procedure aVigenereEncryptExecute(Sender: TObject);
    procedure aVigenereDecryptUpdate(Sender: TObject);
    procedure aVigenereDecryptExecute(Sender: TObject);
    procedure aHistoryExecute(Sender: TObject);
    procedure aFindExecute(Sender: TObject);
    procedure eFindChange(Sender: TObject);
    procedure cbFindMatchCaseClick(Sender: TObject);
    procedure aFindNextUpdate(Sender: TObject);
    procedure aFindNextExecute(Sender: TObject);
    procedure aFindPrevUpdate(Sender: TObject);
    procedure aFindPrevExecute(Sender: TObject);
    procedure EditorFindDataClear(Sender: TObject);
    procedure eFindKeyPress(Sender: TObject; var Key: Char);
    procedure aReplaceExecute(Sender: TObject);
    procedure aGoToExecute(Sender: TObject);
    procedure aStatusBarUpdate(Sender: TObject);
    procedure aStatusBarExecute(Sender: TObject);
    procedure aRulerUpdate(Sender: TObject);
    procedure aRulerExecute(Sender: TObject);
    procedure aToggleFocusExecute(Sender: TObject);
    procedure aDateTimeExecute(Sender: TObject);
    procedure aCustomDateTimeExecute(Sender: TObject);
    procedure aInsertCharExecute(Sender: TObject);
    procedure StatusBarResize(Sender: TObject);
    procedure EditorSelChange(Sender: TObject);
    procedure EditorSimpleNotification(Sender: TObject; MsgID: Cardinal;
      const AStr: string);
    procedure EditorKeyPress(Sender: TObject; var Key: Char);
    procedure TabListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure ZoomControlChange(Sender: TObject);
    procedure EditorZoomChange(Sender: TObject);
    procedure StatusBarContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure StatusBarDblClick(Sender: TObject);
    procedure aMakeUniqueUpdate(Sender: TObject);
    procedure aMakeUniqueExecute(Sender: TObject);
    procedure aNextTabUpdate(Sender: TObject);
    procedure aNextTabExecute(Sender: TObject);
    procedure aPrevTabUpdate(Sender: TObject);
    procedure aPrevTabExecute(Sender: TObject);
    procedure aHTMLH1Execute(Sender: TObject);
    procedure aHTMLH2Execute(Sender: TObject);
    procedure aHTMLH3Execute(Sender: TObject);
    procedure aHTMLH4Execute(Sender: TObject);
    procedure aHTMLH5Execute(Sender: TObject);
    procedure aHTMLH6Execute(Sender: TObject);
    procedure aHTMLPExecute(Sender: TObject);
    procedure aHTMLDivExecute(Sender: TObject);
    procedure aHTMLBrExecute(Sender: TObject);
    procedure aHTMLULExecute(Sender: TObject);
    procedure aHTMLOLExecute(Sender: TObject);
    procedure aHTMLLIExecute(Sender: TObject);
    procedure aHTMLnbspExecute(Sender: TObject);
    procedure aHTMLBExecute(Sender: TObject);
    procedure aHTMLIExecute(Sender: TObject);
    procedure aHTMLEMExecute(Sender: TObject);
    procedure aHTMLstrongExecute(Sender: TObject);
    procedure aHTMLUExecute(Sender: TObject);
    procedure aHTMLspanExecute(Sender: TObject);
    procedure aHTMLtableExecute(Sender: TObject);
    procedure aHTMLtrExecute(Sender: TObject);
    procedure aHTMLthExecute(Sender: TObject);
    procedure aHTMLtdExecute(Sender: TObject);
    procedure aFontExecute(Sender: TObject);
    procedure aPasteAsExecute(Sender: TObject);
    procedure aPasteAsUpdate(Sender: TObject);
    procedure EditorOverwriteChange(Sender: TObject);
    procedure aInsertColorExecute(Sender: TObject);
    procedure aSetBgColorExecute(Sender: TObject);
    procedure aSetRowHighlightColorExecute(Sender: TObject);
    procedure aSetSelBgColorExecute(Sender: TObject);
    procedure aSetSelFgColorExecute(Sender: TObject);
    procedure aSetSearchHighlightColorExecute(Sender: TObject);
    procedure aSetSearchHighlightTextColorExecute(Sender: TObject);
    procedure aSetBracketHighlightColorExecute(Sender: TObject);
    procedure aSetTextColorExecute(Sender: TObject);
    procedure aSetRulerBackgroundColorExecute(Sender: TObject);
    procedure aSetRulerTextColorExecute(Sender: TObject);
    procedure aUseSystemDefaultColorsUpdate(Sender: TObject);
    procedure aUseSystemDefaultColorsExecute(Sender: TObject);
    procedure aSetBgColorUpdate(Sender: TObject);
    procedure aSetTextColorUpdate(Sender: TObject);
    procedure aSetSelBgColorUpdate(Sender: TObject);
    procedure aSetSelFgColorUpdate(Sender: TObject);
    procedure aFPXMLExecute(Sender: TObject);
    procedure aFPXMLUpdate(Sender: TObject);
    procedure aFPHTMLExecute(Sender: TObject);
    procedure aFPHTMLUpdate(Sender: TObject);
    procedure aFPCSSExecute(Sender: TObject);
    procedure aFPCSSUpdate(Sender: TObject);
    procedure aFPMWExecute(Sender: TObject);
    procedure aFPMWUpdate(Sender: TObject);
    procedure aFPINIExecute(Sender: TObject);
    procedure aFPINIUpdate(Sender: TObject);
    procedure aFPPascalExecute(Sender: TObject);
    procedure aFPPascalUpdate(Sender: TObject);
    procedure aFPASExecute(Sender: TObject);
    procedure aFPASUpdate(Sender: TObject);
    procedure aFPNoneExecute(Sender: TObject);
    procedure aFPNoneUpdate(Sender: TObject);
    procedure aRowHighlightExecute(Sender: TObject);
    procedure aRowHighlightUpdate(Sender: TObject);
    procedure aBracketHighlightExecute(Sender: TObject);
    procedure aBracketHighlightUpdate(Sender: TObject);
    procedure aHiddenCharsExecute(Sender: TObject);
    procedure aHiddenCharsUpdate(Sender: TObject);
    procedure aCaretBeyondEOLExecute(Sender: TObject);
    procedure aCaretBeyondEOLUpdate(Sender: TObject);
    procedure aAutoIndentExecute(Sender: TObject);
    procedure aAutoIndentUpdate(Sender: TObject);
    procedure aAutoReplaceExecute(Sender: TObject);
    procedure aAutoReplaceUpdate(Sender: TObject);
    procedure aSetTabLengthExecute(Sender: TObject);
    procedure aReadOnlyExecute(Sender: TObject);
    procedure aReadOnlyUpdate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure aRestoreSettingsExecute(Sender: TObject);
    procedure aSettingsExecute(Sender: TObject);
    procedure EditorPrintBegin(Sender: TObject; NumSteps: Integer);
    procedure EditorPrintEnd(Sender: TObject);
    function EditorPrintProgress(Sender: TObject; CurStep,
      NumSteps: Integer): Boolean;
    procedure aEncUTF8Update(Sender: TObject);
    procedure aEncUTF8Execute(Sender: TObject);
    procedure aEncASCIIExecute(Sender: TObject);
    procedure aEncASCIIUpdate(Sender: TObject);
    procedure aEncUTF16LEUpdate(Sender: TObject);
    procedure aEncUTF16LEExecute(Sender: TObject);
    procedure aEncUTF16BEUpdate(Sender: TObject);
    procedure aEncUTF16BEExecute(Sender: TObject);
    procedure aEncANSIExecute(Sender: TObject);
    procedure aEncANSIUpdate(Sender: TObject);
    procedure aEncUTF32LEExecute(Sender: TObject);
    procedure aEncUTF32LEUpdate(Sender: TObject);
    procedure aEncUTF32BEExecute(Sender: TObject);
    procedure aEncUTF32BEUpdate(Sender: TObject);
    procedure aEncMagicBytesExecute(Sender: TObject);
    procedure aEncMagicBytesUpdate(Sender: TObject);
    procedure aEncCRLFExecute(Sender: TObject);
    procedure aEncCRLFUpdate(Sender: TObject);
    procedure aEncLFUpdate(Sender: TObject);
    procedure aEncLFExecute(Sender: TObject);
    procedure EditorModified(Sender: TObject);
    procedure TabsMenuOpen(Sender: TObject);
    procedure aFillWithcharUpdate(Sender: TObject);
    procedure aFillWithcharExecute(Sender: TObject);
    procedure aBlockPasteUpdate(Sender: TObject);
    procedure aBlockPasteExecute(Sender: TObject);
    procedure aStatisticsExecute(Sender: TObject);
    procedure aTruncateAtExecute(Sender: TObject);
    procedure aAboutExecute(Sender: TObject);
    procedure aTipOfTheDayExecute(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure aSetFPAssocExecute(Sender: TObject);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure aHelpExecute(Sender: TObject);
    procedure ApplicationEventsModalBegin(Sender: TObject);
    procedure ApplicationEventsModalEnd(Sender: TObject);
    procedure aFilterExecute(Sender: TObject);
    procedure aDuplicateBufferExecute(Sender: TObject);
    procedure aSelectionToNewBufferExecute(Sender: TObject);
    procedure aSelectionToNewBufferUpdate(Sender: TObject);
    procedure ApplicationEventsSettingChange(Sender: TObject; Flag: Integer;
      const Section: string; var Result: Integer);
    procedure aSaveUpdate(Sender: TObject);
    procedure aSaveAsUpdate(Sender: TObject);
    procedure aSaveAllExecute(Sender: TObject);
    procedure aCloseAllExecute(Sender: TObject);
    procedure aCloseAllWithoutSaveExecute(Sender: TObject);
    procedure aCheckASCIIExecute(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure aLoremIpsumExecute(Sender: TObject);
    procedure aStatusMsgCopyExecute(Sender: TObject);
    procedure aShowAutoReplaceListExecute(Sender: TObject);
    procedure EditorNotification(Sender: TObject; MsgID: Cardinal;
      AClear: Boolean);
    procedure aNotificationWindowUpdate(Sender: TObject);
    procedure aNotificationWindowExecute(Sender: TObject);
    procedure aAdvStatisticsExecute(Sender: TObject);
    procedure aChrFindExecute(Sender: TObject);
    procedure OpenMnuURL(Sender: TObject);
    procedure aItUpperCaseExecute(Sender: TObject);
    procedure aItLowerCaseExecute(Sender: TObject);
    procedure aItSuperscriptExecute(Sender: TObject);
    procedure aItSubscriptExecute(Sender: TObject);
    procedure aItParenthesizedExecute(Sender: TObject);
    procedure aItCircledExecute(Sender: TObject);
    procedure aItDoublyCircledExecute(Sender: TObject);
    procedure aItNoneExecute(Sender: TObject);
    procedure aItUpperCaseUpdate(Sender: TObject);
    procedure aItLowerCaseUpdate(Sender: TObject);
    procedure aItSuperscriptUpdate(Sender: TObject);
    procedure aItSubscriptUpdate(Sender: TObject);
    procedure aItParenthesizedUpdate(Sender: TObject);
    procedure aItCircledUpdate(Sender: TObject);
    procedure aItDoublyCircledUpdate(Sender: TObject);
    procedure aItNoneUpdate(Sender: TObject);
    procedure aInsertCharByDescriptionSearchExecute(Sender: TObject);
    procedure aReverseTextUpdate(Sender: TObject);
    procedure aReverseTextExecute(Sender: TObject);
    procedure aFindCurrentSymbolExecute(Sender: TObject);
    procedure aFindCurrentSymbolUpdate(Sender: TObject);
    procedure aFindCurrentSymbolPascalExecute(Sender: TObject);
    procedure aFindCurrentSymbolPascalUpdate(Sender: TObject);
    procedure TabListExit(Sender: TObject);
    procedure aCopyFileNameExecute(Sender: TObject);
    procedure TabListTabMoved(Sender: TObject; TabIndex, InsertionPos: Integer);
    procedure TabListTabCanSendAway(Sender: TObject; TabIndex: Integer;
      var Data: pointer; var Len: UInt64; var CanSend: Boolean);
    procedure TabListTabCanInsert(Sender: TObject; const Data: pointer;
      const Len: UInt64; InsertionPos: Integer; var CanInsert: Boolean);
    procedure TabListTabInserted(Sender: TObject; const Data: pointer;
      const Len: UInt64; InsertionPos: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure aNewWindowExecute(Sender: TObject);
    procedure TabListTabSentAway(Sender: TObject; TabIndex: Integer);
    procedure aDetachExecute(Sender: TObject);
    procedure aCloseOtherExecute(Sender: TObject);
    procedure aCloseOtherUpdate(Sender: TObject);
    procedure aCompareExecute(Sender: TObject);
  private const
    SYN_XML = 0;
    SYN_HTML = 1;
    SYN_CSS = 2;
    SYN_MW = 3;
    SYN_PAS = 4;
    SYN_AS = 5;
    SYN_INI = 6;
    SYN_HIGH = 6;
  private const
    DEFAULT_ASSOC_XML = 'xml,xsd,xsl,svg,rss,atom,xul,wml';
    DEFAULT_ASSOC_HTML = 'xhtml,html,htm,asp,php';
    DEFAULT_ASSOC_CSS = 'css';
    DEFAULT_ASSOC_MW = '';
    DEFAULT_ASSOC_PAS = 'pas,dpr';
    DEFAULT_ASSOC_AS = 'prg';
    DEFAULT_ASSOC_INI = 'ini,inf,url,book,shelf,iss';
  private var
    FFirstTimeChrDlg: boolean;
    FTextFiles: TArray<TTextFile>;
    FSynHighlightAssocs: array[0..SYN_HIGH] of string;
    FReadOnlyAssocs: string;
    FTrimAssocs: string;
    FAutoTip: boolean;
    FFirstActivate: boolean;
    FOldDefaultEffect: TBitmapEffect;
    FDisabledByModality: boolean;
    FDragDataObj: IDataObject;
    FDragCompatFmt: boolean;
    procedure UpdateTabs;
    procedure SetWindowCaption;
    procedure ShowErrorMessage(const Str: string);
    procedure DoInstantSearch;
    procedure StatusBarCharacterInfo(c: Char);
    function GetSizeGripSize: integer;
    function HasImportantNotification: boolean;
    procedure InsertTags(const TagName: string);
    procedure InsertTag(const TagName: string);
    procedure FontDialogApply(Sender: TObject; Wnd: HWND);
    function SelectColor(var AColor: TColor): boolean;
    procedure ApplyAssocFormattingProcessor;
    procedure ApplyAssocReadOnlyMode;
    procedure EncodingMenuSelect;
    procedure TabsMenuItemClick(Sender: TObject);
    procedure TaskDialogHyperLinkClicked(Sender: TObject);
    procedure TipOfTheDayVerificationClicked(Sender: TObject);
    procedure ShowSettingsDialog(DefaultTab: Integer = 0);
    procedure LoadRTEFile(const AFileName: TFileName);
    procedure LoadSingleInstanceRTEFile(const AFileName: TFileName);
    function GetTrimRight(const AFileName: TFileName): boolean;
    procedure UpdateNotificationsWindow;
    function GetLastNotification: string;
    function GetInitialFileName(const ATextFile: TTextFile): string;
    procedure SaveAsDialogExecute(Sender: TObject);
    procedure SaveAsDialogOnOKClick(Sender: TObject; var CanClose: boolean);
    procedure OpenDialogExecute(Sender: TObject);
    procedure OpenDialogOkClick(Sender: TObject; var CanClose: boolean);
    procedure DoFindSymbol(APascal: boolean = false);
    function AppendExternalTab(TabControl: HWND; TabIndex: integer;
      const TabName: string; dataObj: IDataObject): boolean;
    procedure CompareBuffers(ALeftIndex, ARightIndex: integer);
  protected
    procedure WMDropFiles(var Message: TWMDropFiles); message WM_DROPFILES;
    procedure WMExitMenuLoop(var Message: TWMExitMenuLoop);
      message WM_EXITMENULOOP;
    procedure WMQueryPrevInst(var Message: TMessage); message WM_QUERYPREVINST;
    procedure WMCopyData(var Message: TWMCopyData); message WM_COPYDATA;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;

    { IDropTarget }
    function IDropTarget.DragEnter = DropTargetDragEnter;
    function DropTargetDragEnter(const dataObj: IDataObject;
      grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT;
      stdcall;
    function IDropTarget.DragOver = DropTargetDragOver;
    function DropTargetDragOver(grfKeyState: Longint; pt: TPoint;
      var dwEffect: Longint): HRESULT;
      stdcall;
    function IDropTarget.DragLeave = DropTargetDragLeave;
    function DropTargetDragLeave: HRESULT;
      stdcall;
    function IDropTarget.Drop = DropTargetDrop;
    function DropTargetDrop(const dataObj: IDataObject; grfKeyState:
      Longint; pt: TPoint; var dwEffect: Longint): HRESULT; stdcall;

  public
    { Public declarations }
    FKeyPressed: boolean;
    FDoAbortPrinting: boolean;
    procedure GotoFile(FileIndex: integer);
    procedure NewFile;
    procedure LoadFile(const AFileName: TFileName; AReadOnly: boolean = false);
    procedure LoadFiles(const AFileNames: array of string);
    function CloseFile(FileIndex: integer; CloseApp: boolean = true): boolean;
    function SaveFile(FileIndex: integer): boolean;
    function SaveFileAs(FileIndex: integer): boolean;
    function QueryFileSave(FileIndex: integer): boolean;
    function ActiveFileIndex: integer;
    procedure SaveSettingsToFile;
    procedure LoadSettingsFromFile;
    procedure RestoreDefaultSettings;
    procedure CharacterInfo(const AChar: char);
    function GetHTMLExportFileName: string;
    function GetSettingsFileName: string;
    procedure NewBufferWithContents(const S: string);
  end;

var
  RejbrandTextEditor: TRejbrandTextEditor;

const
  STATUS_FILE_POSITION = 0;
  STATUS_OVERWRITE = 1;
  STATUS_MESSAGE = 2;
  STATUS_ZOOM_CONTROL = 3;

implementation

uses Math, Themes, ShellAPI, ShlObj, AxCtrls, SHFolder, wwpWin, sortWin, historyWin,
  replaceWin, MultiInput, timeWin, chrWin, UnicodeData, Clipbrd, pasteAsWin,
  StrUtils, ColorDialog, IniFiles, settingsWin, printingWin,
  Printers, selEncWin, statisticsWin, truncateWin, filterWin, RichEdit,
  notificationsWin, advstatisticsWin, chrSearchWin, compareWin;

{$R *.dfm}

type
  TVerInfo = packed record
    vMajor, vMinor, vRelease, vBuild: word;
  end;

function ExtractFileExt(const S: string): string;
begin
  result := SysUtils.ExtractFileExt(S);
  if result = '' then Exit;
  if result[1] = '.' then Delete(result, 1, 1);
end;

function ItemInList(const Item, List: string): boolean;
var
  i, last: integer;
begin
  result := false;
  if Item = '' then Exit;
  last := 1;
  for i := 1 to Length(List) + 1 do
    if (i = Length(List) + 1) or (List[i] = ',') then
    begin
      if SameText(Item, Trim(Copy(List, last, i - last))) then
        Exit(true);
      last := i + 1;
    end;
end;

function GetFileVerNumbers(const FileName: string): TVerInfo;
var
  len, dummy: cardinal;
  verdata: pointer;
  verstruct: pointer;
const
  InvalidVersion: TVerInfo = (vMajor: 0; vMinor: 0; vRelease: 0; vBuild: 0);
begin
  len := GetFileVersionInfoSize(PWideChar(FileName), dummy);
  if len = 0 then
    Exit(InvalidVersion);
  GetMem(verdata, len);
  try
    GetFileVersionInfo(PWideChar(FileName), 0, len, verdata);
    VerQueryValue(verdata, '\', verstruct, dummy);
    result.vMajor := HiWord(TVSFixedFileInfo(verstruct^).dwFileVersionMS);
    result.vMinor := LoWord(TVSFixedFileInfo(verstruct^).dwFileVersionMS);
    result.vRelease := HiWord(TVSFixedFileInfo(verstruct^).dwFileVersionLS);
    result.vBuild := LoWord(TVSFixedFileInfo(verstruct^).dwFileVersionLS);
  finally
    FreeMem(verdata);
  end;
end;

function GetFileVer(const FileName: string): string;
begin
  with GetFileVerNumbers(FileName) do
    result := IntToStr(vMajor) + '.' + IntToStr(vMinor) + '.' + IntToStr(vRelease) + '.' + IntToStr(vBuild);
end;

procedure TRejbrandTextEditor.aAboutExecute(Sender: TObject);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'About Rejbrand Text Editor';
        Title := 'Rejbrand Text Editor';
        CommonButtons := [tcbClose];
        Text := 'Application version: ' + GetFileVer(Application.ExeName) + #13#10#13#10'Copyright © 2008–2019 Andreas Rejbrand'#13#10#13#10'<a href="https://english.rejbrand.se">https://english.rejbrand.se</a>';
        Flags := [tfUseHiconMain, tfEnableHyperlinks, tfAllowDialogCancellation];
        FooterText := 'Unicode version: ' + UCDUnicodeVersion{$IFDEF DEBUG}+sLineBreak+sLineBreak+'DEBUG'{$ENDIF};
        CustomMainIcon := Application.Icon;
        OnHyperlinkClicked := TaskDialogHyperlinkClicked;
        ExecuteModally;
      finally
        Free;
      end
  else
    // Windows XP Compatibility Code
    MessageBox(Handle, PChar('File Version: ' + GetFileVer(Application.ExeName) + #13#10#13#10 + 'Copyright © 2008–2019 Andreas Rejbrand' + #13#10#13#10 + 'https://english.rejbrand.se' + #13#10#13#10 + 'Rejbrand Text Editor is running in Windows XP Compatibility Mode.'), PChar('Rejbrand Text Editor'), MB_ICONINFORMATION);
end;

procedure TRejbrandTextEditor.TaskDialogHyperLinkClicked(Sender: TObject);
begin
  if Sender is TTaskDialog then
    with Sender as TTaskDialog do
      ShellExecute(Handle, 'open', PChar(URL), nil, nil, SW_SHOWNORMAL);
end;

procedure TRejbrandTextEditor.aAddIndentExecute(Sender: TObject);
begin
  Editor.AddIndent;
end;

function TabChecker(C: char): boolean;
begin
  result := C = #9;
end;

procedure TRejbrandTextEditor.aAdvStatisticsExecute(Sender: TObject);
var
  counts: TIntegerArray;
  i, c1, c2, c3: integer;
begin
  with TadvstatisticsFrm.Create(nil) do
    try
      Screen.Cursor := crHourGlass;
      try
        eStats.LoadDefaultClasses;
        eStats.MultiSize := true;
        eStats.AddClass(MakeClass('Empty block', 12, [], clWindowText));
        if GetSysColor(COLOR_WINDOW) = DWORD(clWhite) then
        begin
          eStats.AddClass(MakeClass('Nonempty block', 12, [fsBold], clNavy));
          eStats.AddClass(MakeClass('Beyond BMP', 12, [fsItalic], clGray));
        end
        else
          eStats.AddClass(MakeClass('Nonempty block', 12, [fsBold], clWindowText));
          eStats.AddClass(MakeClass('Beyond BMP', 12, [fsItalic], clWindowText));
        eStats.BeginAddLine;
        counts := Editor.TextFile.GetUnicodeBlockStatistics;
        eStats.AddLine('Unicode blocks', 'Heading 1');
        for i := 0 to Length(counts) - 1 do
          eStats.AddLine(
            UCD.Blocks[i].BlockName +
            DupeString('.', 48 - Length(UCD.Blocks[i].BlockName)) +
            IntToStr(counts[i]),
            IfThen(counts[i] > 0, 'Nonempty block',
              IfThen(UCD.Blocks[i].BlockBegin > $FFFF, 'Beyond BMP', 'Empty block')
            ));

        eStats.AddLine;
        eStats.AddLine('Special characters', 'Heading 1');
        c1 := Editor.TextFile.GetControlCharCount;
        c2 := Editor.TextFile.GetNoncharacterCount;
        c3 := Editor.TextFile.NumCharsOfType(TabChecker);

        eStats.AddLine(
          'Control characters' +
          DupeString('.', 48 - Length('Control characters')) +
          IntToStr(c1),
          IfThen(c1 > 0, 'Nonempty block', 'Empty block'));

        if c1 > 0 then
          eStats.AddLine(
            '... of which are CT (U+0009)' +
            DupeString('.', 48 - Length('... of which are CT (U+0009)')) +
            IntToStr(c3),
            IfThen(c3 > 0, 'Nonempty block', 'Empty block'));

        eStats.AddLine(
          'Noncharacters' +
          DupeString('.', 48 - Length('Noncharacters')) +
          IntToStr(c2),
          IfThen(c2 > 0, 'Nonempty block', 'Empty block'));

        eStats.EndAddLine;
        eStats.EditMode := emReadOnly;
        eStats.TextFile.StrictReadOnly := true;
        eStats.TextFile.UseLineClasses := true;
        eStats.TextFile.GotoSOF;
      finally
        Screen.Cursor := crDefault;
      end;
      ShowModal;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aAutoIndentExecute(Sender: TObject);
begin
  Editor.AutoIndent := not Editor.AutoIndent;
end;

procedure TRejbrandTextEditor.aAutoIndentUpdate(Sender: TObject);
begin
  aAutoIndent.Checked := Editor.AutoIndent;
end;

procedure TRejbrandTextEditor.aAutoReplaceExecute(Sender: TObject);
begin
  Editor.AutoReplace := not Editor.AutoReplace;
end;

procedure TRejbrandTextEditor.aAutoReplaceUpdate(Sender: TObject);
begin
  aAutoReplace.Checked := Editor.AutoReplace;
end;

procedure TRejbrandTextEditor.aBracketHighlightExecute(Sender: TObject);
begin
  Editor.MatchBrackets := not Editor.MatchBrackets;
end;

procedure TRejbrandTextEditor.aBracketHighlightUpdate(Sender: TObject);
begin
  aBracketHighlight.Checked := Editor.MatchBrackets;
end;

procedure TRejbrandTextEditor.TabsMenuOpen(Sender: TObject);
var
  i: Integer;
  mnuItem: TMenuItem;
begin

  for i := mnuTabs.Count - 1 downto 0 do
    with mnuTabs.Items[i] do
      if (Action = nil) and (Caption <> '-') then
        mnuTabs.Delete(i);

  for i := 0 to high(FTextFiles) do
  begin
    mnuItem := TMenuItem.Create(mnuTabs);
    with mnuItem do
    begin
      Caption := ExtractFileName(FTextFiles[i].FileName) + IfThen(FTextFiles[i].FileModified, ' *');
      Tag := i;
      Hint := FTextFiles[i].FileName + IfThen(FTextFiles[i].FileModified, ' (modified)');
      Checked := ActiveFileIndex = i;
      OnClick := TabsMenuItemClick;
    end;
    mnuTabs.Add(mnuItem);
  end;

end;

procedure TRejbrandTextEditor.TabsMenuItemClick(Sender: TObject);
begin
  if Sender is TMenuItem then
    GotoFile(TMenuItem(Sender).Tag);
end;

procedure TRejbrandTextEditor.aCaesarExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_CAESAR);
end;

procedure TRejbrandTextEditor.aCaesarUpdate(Sender: TObject);
begin
  aCaesar.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_CAESAR);
end;

procedure TRejbrandTextEditor.aCamelCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_CAMEL_CASE);
end;

procedure TRejbrandTextEditor.aCamelCaseUpdate(Sender: TObject);
begin
  aCamelCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_CAMEL_CASE);
end;

procedure TRejbrandTextEditor.aCaretBeyondEOLExecute(Sender: TObject);
begin
  Editor.CaretAfterEOL := not Editor.CaretAfterEOL;
end;

procedure TRejbrandTextEditor.aCaretBeyondEOLUpdate(Sender: TObject);
begin
  aCaretBeyondEOL.Checked := Editor.CaretAfterEOL;
end;

procedure TRejbrandTextEditor.aCheckASCIIExecute(Sender: TObject);
var
  y: Integer;
  x: Integer;
begin
  for y := 0 to Editor.LineCount - 1 do
    for x := 0 to Editor.TextFile.VirtualLineWidths[y] - 1 do
      if ord(Editor.TextFile.Character[Y, X]) > 127 then
      begin
        Editor.TextFile.CaretPos.CreateSelection(Point(X, Y), Point(X+1, Y));
        MessageBox(Handle, 'The text contains non-ASCII characters.',
          PChar(ExtractFileName(Editor.TextFile.FileName)), MB_ICONINFORMATION or MB_OK);
        Exit;
      end;

  MessageBox(Handle, 'The text contains only ASCII characters.',
    PChar(ExtractFileName(Editor.TextFile.FileName)), MB_ICONINFORMATION or MB_OK);
end;

procedure TRejbrandTextEditor.aChrFindExecute(Sender: TObject);
begin
  with TchrSearchFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        if rbNonASCII.Checked then
          Editor.Find(MakeFindQuery(FQ_NONASCII))
        else if rbControl.Checked then
          Editor.Find(MakeFindQuery(FQ_CONTROL))
        else if rbNonchars.Checked then
          Editor.Find(MakeFindQuery(FQ_NONCHAR))
        else if rbBlock.Checked then
          Editor.Find(MakeFindQuery(lbBlocks.ItemIndex + 1));
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aClearExecute(Sender: TObject);
begin
  Editor.ClearSelection;
end;

procedure TRejbrandTextEditor.aClearLineExecute(Sender: TObject);
begin
  Editor.ClearLine;
end;

procedure TRejbrandTextEditor.aClearLineUpdate(Sender: TObject);
begin
  aClearLine.Enabled := Editor.TextFile.PhysicalLineWidths[Editor.CaretPos.Y] > 0;
end;

procedure TRejbrandTextEditor.aClearUpdate(Sender: TObject);
begin
  aClear.Enabled := Editor.Focused and Editor.TextFile.HasSelection;
end;

procedure TRejbrandTextEditor.aCloseAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := high(FTextFiles) downto 0 do
    if not CloseFile(i, false) then Exit;
end;

procedure TRejbrandTextEditor.aCloseAllWithoutSaveExecute(Sender: TObject);
var
  i: Integer;
begin

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := 'Are you sure that you want to close all files (tabs) without saving the changes made to them (if any)?';
        Text := 'All changes will be lost. This operation cannot be undone.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Yes, close all without saving';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&No, cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiWarning;
        if ExecuteModally then
          if ModalResult <> mrYes then
            Exit;
      finally
        Free;
      end
  else
    if MessageBox(Handle,
      'Are you sure that you want to close all files (tabs) without saving the changes made to them (if any)?',
      'Rejbrand Text Editor',
      MB_ICONWARNING or MB_YESNOCANCEL) <> ID_YES then
        Exit;

  for i := 0 to high(FTextFiles) do
    FTextFiles[i].FileModified := false;

  aCloseAll.Execute;
end;

procedure TRejbrandTextEditor.aCloseExecute(Sender: TObject);
begin
  CloseFile(ActiveFileIndex);
end;

procedure TRejbrandTextEditor.aCloseOtherExecute(Sender: TObject);
var
  Cur, i: Integer;
begin
  Cur := TabList.ActiveTab;
  for i := high(FTextFiles) downto 0 do
    if i <> Cur then
      if not CloseFile(i, false) then Exit;
end;

procedure TRejbrandTextEditor.aCloseOtherUpdate(Sender: TObject);
begin
  aCloseOther.Enabled := TabList.Items.Count > 1;
end;

procedure TRejbrandTextEditor.aCustomDateTimeExecute(Sender: TObject);
begin
  with TtimeFrm.Create(nil) do
    try
      if (ShowModal = mrOk) and (lbFormats.ItemIndex <> -1) then
        Editor.SelText := lbFormats.Items[lbFormats.ItemIndex];
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aCutExecute(Sender: TObject);
begin
  if Editor.Focused then
    Editor.CutToClipboard
  else if Assigned(Screen.ActiveControl) then
    Screen.ActiveControl.Perform(WM_CUT, 0, 0);
end;

procedure TRejbrandTextEditor.aCutUpdate(Sender: TObject);
begin
  aCut.Enabled :=
    (Editor.Focused and Editor.TextFile.HasSelection)
    or
    ((Screen.ActiveControl is TCustomEdit) and (TCustomEdit(Screen.ActiveControl).SelLength <> 0));
end;

procedure TRejbrandTextEditor.aDateTimeExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_WRITE_DATETIME);
end;

procedure TRejbrandTextEditor.aDeleteFileExecute(Sender: TObject);

  procedure DoDeleteFile;
  begin
    if DeleteFile(Editor.TextFile.FileName) then
    begin
      Editor.TextFile.FileModified := true;
      UpdateTabs;
      SetWindowCaption;
    end
    else
      ShowErrorMessage(Format('An error occurred while trying to delete the file "%s".',
        [ExtractFileName(Editor.TextFile.FileName)]));
  end;

begin
  if not FileExists(Editor.TextFile.FileName) then
    Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to delete this file from the file system?';
        FooterText := 'The text will still be available in the editor.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Delete';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              DoDeleteFile;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to delete this file from the file system?',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        DoDeleteFile;
    end;
end;

procedure TRejbrandTextEditor.aDeleteFileUpdate(Sender: TObject);
begin
  aDeleteFile.Enabled := FileExists(Editor.TextFile.FileName) and
    not Editor.TextFile.StrictReadOnly;
end;

type
  PPIDHWND = ^TPIDHWND;
  TPIDHWND = record
    PID: DWORD;
    HWND: HWND;
  end;

function EWP_FindNewRTEWindow(hwnd: HWND; lparam: LPARAM): BOOL; stdcall;
var
  pid: DWORD;
  ClassName: array[0..128] of char;
begin
  GetWindowThreadProcessId(hwnd, pid);
  GetClassName(hwnd, @ClassName[0], Length(ClassName));
  if (pid = PPIDHWND(lparam).PID) and SameText(ClassName, RTE_WNDCLASS_NAME) then
  begin
    PPIDHWND(lparam).HWND := hwnd;
    result := false;
  end
  else
  begin
    PPIDHWND(lparam).HWND := 0;
    result := true;
  end;
end;

procedure TRejbrandTextEditor.aDetachExecute(Sender: TObject);
var
  CDS: TCopyDataStruct;
  stm: TMemoryStream;
  NewHWND: HWND;
  SI: TStartupInfo;
  PI: TProcessInformation;
  RWPData: TPIDHWND;
begin

  // Step 1: Obtain text file stream
  stm := TMemoryStream.Create;
  try

    Editor.PushEditorState;
    Editor.TextFile.SaveToStream(stm);

    // Step 2: Fill in the TCopyDataStruct record
    FillChar(CDS, sizeof(CDS), 0);
    CDS.dwData := RTE_COPYDATA_TEXTFILE or RTE_COPYDATA_FLAG_CLOSEDUMMY;
    CDS.cbData := stm.Size;
    CDS.lpData := stm.Memory;

    // Step 3: Create a new RTE process
    FillChar(SI, sizeof(SI), 0);
    SI.cb := sizeof(SI);
    FillChar(PI, sizeof(PI), 0);
    if not CreateProcess(PChar(Application.ExeName), nil, nil, nil, false, 0, nil,
      nil, SI, PI) then
    begin
      ShowErrorMessage('Couldn''t create new instance of the text editor.');
      Exit;
    end;

    try

      if WaitForInputIdle(PI.hProcess, 5000) <> 0 then
      begin
        ShowErrorMessage('New text editor process not ready soon enough.');
        Exit;
      end;

      // Step 4: Obtain the main window handle of the new RTE instance
      FillChar(RWPData, sizeof(RWPData), 0);
      RWPData.PID := PI.dwProcessId;
      EnumWindows(@EWP_FindNewRTEWindow, NativeInt(@RWPData));
      if RWPData.HWND = 0 then
      begin
        ShowErrorMessage('Couldn''t find new text editor window.');
        Exit;
      end;

      NewHWND := RWPData.HWND;

      // Step 5: Test if the window is available, responding, comaptible, and ready
      if SendMessage(NewHWND, WM_QUERYPREVINST, 0, 0) <> PREVINST_READY then
      begin
        ShowErrorMessage('New text editor window not responding properly.');
        Exit;
      end;

      // Step 6: Send the text file stream
      if SendMessage(NewHWND, WM_COPYDATA, Handle, NativeInt(@CDS)) <> 1 then
      begin
        ShowErrorMessage('Couldn''t send the text file stream to the new instance of the text editor.');
        Exit;
      end;

    finally
      CloseHandle(PI.hProcess);
      CloseHandle(PI.hThread);
    end;

    // Step 7: Everything OK, close our copy of the text file
    Editor.TextFile.FileModified := false;
    CloseFile(TabList.ActiveTab);

  finally
    stm.Free;
  end;

end;

procedure TRejbrandTextEditor.aDuplicateBufferExecute(Sender: TObject);
begin
  NewBufferWithContents(Editor.PlainText);
end;

procedure TRejbrandTextEditor.aEncANSIExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teWindows8bitCodepage);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncANSIUpdate(Sender: TObject);
begin
  aEncANSI.Checked := Editor.TextFile.Encoding.TextEncoding = teWindows8bitCodepage;
end;

procedure TRejbrandTextEditor.aEncASCIIExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teASCII);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncASCIIUpdate(Sender: TObject);
begin
  aEncASCII.Checked := Editor.TextFile.Encoding.TextEncoding = teASCII;
end;

procedure TRejbrandTextEditor.aEncCRLFExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetLineBreakType(lbtCRLF);
end;

procedure TRejbrandTextEditor.aEncCRLFUpdate(Sender: TObject);
begin
  aEncCRLF.Checked := Editor.TextFile.Encoding.LineBreakType = lbtCRLF;
end;

procedure TRejbrandTextEditor.aEncLFExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetLineBreakType(lbtLF);
end;

procedure TRejbrandTextEditor.aEncLFUpdate(Sender: TObject);
begin
  aEncLF.Checked := Editor.TextFile.Encoding.LineBreakType = lbtLF;
end;

procedure TRejbrandTextEditor.aEncMagicBytesExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetMagicWord(not Editor.TextFile.Encoding.MagicWord);
end;

procedure TRejbrandTextEditor.aEncMagicBytesUpdate(Sender: TObject);
begin
  aEncMagicBytes.Checked := Editor.TextFile.Encoding.MagicWord;
end;

procedure TRejbrandTextEditor.aEncUTF16BEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF16BE);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncUTF16BEUpdate(Sender: TObject);
begin
  aEncUTF16BE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF16BE;
end;

procedure TRejbrandTextEditor.aEncUTF16LEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF16LE);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncUTF16LEUpdate(Sender: TObject);
begin
  aEncUTF16LE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF16LE;
end;

procedure TRejbrandTextEditor.aEncUTF32BEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF32BE);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncUTF32BEUpdate(Sender: TObject);
begin
  aEncUTF32BE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF32BE;
end;

procedure TRejbrandTextEditor.aEncUTF32LEExecute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF32LE);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncUTF32LEUpdate(Sender: TObject);
begin
  aEncUTF32LE.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF32LE;
end;

procedure TRejbrandTextEditor.aEncUTF8Execute(Sender: TObject);
begin
  Editor.TextFile.Encoding.SetEncoding(teUTF8);
  EncodingMenuSelect;
end;

procedure TRejbrandTextEditor.aEncUTF8Update(Sender: TObject);
begin
  aEncUTF8.Checked := Editor.TextFile.Encoding.TextEncoding = teUTF8;
end;

procedure TRejbrandTextEditor.aExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TRejbrandTextEditor.aFillWithcharExecute(Sender: TObject);
var
  v: char;
begin
  v := 'A';
  if TMultiInputBox.CharInputBox(Self, 'Fill with character',
    'Please enter the character to fill the selection with:', v) then
    Editor.FillWithChar(v)
end;

procedure TRejbrandTextEditor.aFillWithcharUpdate(Sender: TObject);
begin
  aFillWithchar.Enabled := Editor.TextFile.HasSelection;
end;

procedure TRejbrandTextEditor.aFilterExecute(Sender: TObject);
begin
  with TfilterFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        Editor.Filter(eContains.Text, eStarts.Text, eEnds.Text,
          cbCaseSensitive.Checked, rbRemove.Checked);
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aFindCurrentSymbolExecute(Sender: TObject);
begin
  DoFindSymbol;
end;

procedure TRejbrandTextEditor.aFindCurrentSymbolPascalExecute(Sender: TObject);
begin
  DoFindSymbol(true);
end;

procedure TRejbrandTextEditor.aFindCurrentSymbolPascalUpdate(Sender: TObject);
begin
  aFindCurrentSymbolPascal.Enabled := Editor.TextFile.HasSelection or not Editor.GetWord.IsEmpty;
end;

procedure TRejbrandTextEditor.aFindCurrentSymbolUpdate(Sender: TObject);
begin
  aFindCurrentSymbol.Enabled := Editor.TextFile.HasSelection or not Editor.GetWord.IsEmpty;
end;

procedure TRejbrandTextEditor.aFindExecute(Sender: TObject);
begin
  pnSearch.Show;
  if TabList.Visible then
    TabList.Top := 0;
  if eFind.CanFocus then
  begin
    eFind.SetFocus;
    eFind.SelectAll;
  end;
end;

procedure TRejbrandTextEditor.aFindNextExecute(Sender: TObject);
begin
  Editor.FindNext;
end;

procedure TRejbrandTextEditor.aFindNextUpdate(Sender: TObject);
begin
  aFindNext.Enabled := Editor.TextFile.FindCount > 0;
end;

procedure TRejbrandTextEditor.aFindPrevExecute(Sender: TObject);
begin
  Editor.FindPrevious;
end;

procedure TRejbrandTextEditor.aFindPrevUpdate(Sender: TObject);
begin
  aFindPrev.Enabled := Editor.TextFile.FindCount > 0;
end;

procedure TRejbrandTextEditor.FontDialogApply(Sender: TObject; Wnd: HWND);
begin
  if Sender is TFontDialog then
    Editor.Font.Assign(TFontDialog(Sender).Font);
end;

procedure TRejbrandTextEditor.aFontExecute(Sender: TObject);
begin
  with TFontDialog.Create(nil) do
    try
      Font.Assign(Editor.Font);
      Options := [fdFixedPitchOnly, fdForceFontExist, fdApplyButton];
      OnApply := FontDialogApply;
      if Execute then
        Editor.Font.Assign(Font);
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aFPASExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := AlgoSimFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPASUpdate(Sender: TObject);
begin
  aFPAS.Checked := Editor.FormattingProcessor = AlgoSimFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPCSSExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := CSSFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPCSSUpdate(Sender: TObject);
begin
  aFPCSS.Checked := Editor.FormattingProcessor = CSSFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPHTMLExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := HTMLFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPHTMLUpdate(Sender: TObject);
begin
  aFPHTML.Checked := Editor.FormattingProcessor = HTMLFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPINIExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := INIFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPINIUpdate(Sender: TObject);
begin
  aFPINI.Checked := Editor.FormattingProcessor = INIFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPMWExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := MediaWikiFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPMWUpdate(Sender: TObject);
begin
  aFPMW.Checked := Editor.FormattingProcessor = MediaWikiFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPNoneExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := nil;
end;

procedure TRejbrandTextEditor.aFPNoneUpdate(Sender: TObject);
begin
  aFPNone.Checked := Editor.FormattingProcessor = nil;
end;

procedure TRejbrandTextEditor.aFPPascalExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := PascalFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPPascalUpdate(Sender: TObject);
begin
  aFPPascal.Checked := Editor.FormattingProcessor = PascalFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPXMLExecute(Sender: TObject);
begin
  Editor.FormattingProcessor := XMLFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aFPXMLUpdate(Sender: TObject);
begin
  aFPXML.Checked := Editor.FormattingProcessor = XMLFormattingProcessor1;
end;

procedure TRejbrandTextEditor.aGoToExecute(Sender: TObject);
var
  v: integer;
begin
  v := Editor.CaretPos.Y + 1;
  if TMultiInputBox.NumInputBox(Self,
    'Go to', 'Please enter a line number to go to:', v, 1, Editor.LineCount) then
    Editor.CaretPos := Point(0, v - 1);
end;

function GetDriveAccess: string;
var
  path: array [0..MAX_PATH] of char;
begin
  SHGetFolderPath(0, CSIDL_APPDATA, 0, SHGFP_TYPE_CURRENT, @path);
  result := path + '\Rejbrand\Rejbrand Text Editor\3.0\';
  ForceDirectories(result);
end;

function TRejbrandTextEditor.GetHTMLExportFileName: string;
begin
  result := GetDriveAccess + 'export.html';
end;

procedure TRejbrandTextEditor.aHelpExecute(Sender: TObject);
begin
  LoadSingleInstanceRTEFile(ExtractFilePath(Application.ExeName) + 'Help.rte');
end;

procedure TRejbrandTextEditor.aHiddenCharsExecute(Sender: TObject);
begin
  Editor.ShowHiddenCharacters := not Editor.ShowHiddenCharacters;
end;

procedure TRejbrandTextEditor.aHiddenCharsUpdate(Sender: TObject);
begin
  aHiddenChars.Checked := Editor.ShowHiddenCharacters;
end;

procedure TRejbrandTextEditor.aHistoryExecute(Sender: TObject);
var
  i: integer;
begin
  Editor.TypeTimerEnd;
  with ThistoryFrm.Create(nil) do
    try
      lvHistory.Items.BeginUpdate;
      for i := Editor.TextFile.HistoryManager.FirstItem to Editor.TextFile.HistoryManager.LastItem do
        with lvHistory.Items.Add, Editor.TextFile.HistoryManager.UndoData[i] do
        begin
          Caption := IntToStr(i + 1);
          SubItems.Add(DateTimeToStr(Time));
          Subitems.Add(IntToStr(Length(Text)));
          SubItems.Add(Comment);
        end;
      lvHistory.Items.EndUpdate;
      lvHistory.ItemIndex := Editor.TextFile.HistoryManager.HistoryIndex - Editor.TextFile.HistoryManager.FirstItem;

      StatusBar1.SimplePanel := true;
      StatusBar1.SimpleText := Format('%d item(s), %s in total',
        [Editor.TextFile.HistoryManager.Count,
         FormatDataSize(Editor.TextFile.HistoryManager.Size)]);
      ShowModal;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aHTMLBExecute(Sender: TObject);
begin
  InsertTags('b');
end;

procedure TRejbrandTextEditor.aHTMLBrExecute(Sender: TObject);
begin
  InsertTag('br');
end;

procedure TRejbrandTextEditor.aHTMLDivExecute(Sender: TObject);
begin
  InsertTags('div');
end;

procedure TRejbrandTextEditor.aHTMLEMExecute(Sender: TObject);
begin
  InsertTags('em');
end;

procedure TRejbrandTextEditor.aHTMLExportExecute(Sender: TObject);
var
  S: string;
begin
  S := GetHTMLExportFileName;
  Editor.ExportToHTML(S);
  LoadFile(S);
end;

procedure TRejbrandTextEditor.aHTMLH1Execute(Sender: TObject);
begin
  InsertTags('h1');
end;

procedure TRejbrandTextEditor.aHTMLH2Execute(Sender: TObject);
begin
  InsertTags('h2');
end;

procedure TRejbrandTextEditor.aHTMLH3Execute(Sender: TObject);
begin
  InsertTags('h3');
end;

procedure TRejbrandTextEditor.aHTMLH4Execute(Sender: TObject);
begin
  InsertTags('h4');
end;

procedure TRejbrandTextEditor.aHTMLH5Execute(Sender: TObject);
begin
  InsertTags('h5');
end;

procedure TRejbrandTextEditor.aHTMLH6Execute(Sender: TObject);
begin
  InsertTags('h6');
end;

procedure TRejbrandTextEditor.aHTMLIExecute(Sender: TObject);
begin
  InsertTags('i');
end;

procedure TRejbrandTextEditor.aHTMLLIExecute(Sender: TObject);
begin
  InsertTags('li');
end;

procedure TRejbrandTextEditor.aHTMLnbspExecute(Sender: TObject);
begin
  Editor.SelText := '&nbsp;';
end;

procedure TRejbrandTextEditor.aHTMLOLExecute(Sender: TObject);
begin
  InsertTags('ol');
end;

procedure TRejbrandTextEditor.aHTMLPExecute(Sender: TObject);
begin
  InsertTags('p');
end;

procedure TRejbrandTextEditor.aHTMLspanExecute(Sender: TObject);
begin
  InsertTags('span');
end;

procedure TRejbrandTextEditor.aHTMLstrongExecute(Sender: TObject);
begin
  InsertTags('strong');
end;

procedure TRejbrandTextEditor.aHTMLtableExecute(Sender: TObject);
begin
  InsertTags('table');
end;

procedure TRejbrandTextEditor.aHTMLtdExecute(Sender: TObject);
begin
  InsertTags('td');
end;

procedure TRejbrandTextEditor.aHTMLthExecute(Sender: TObject);
begin
  InsertTags('th');
end;

procedure TRejbrandTextEditor.aHTMLtrExecute(Sender: TObject);
begin
  InsertTags('tr');
end;

procedure TRejbrandTextEditor.aHTMLUExecute(Sender: TObject);
begin
  InsertTags('u');
end;

procedure TRejbrandTextEditor.aHTMLULExecute(Sender: TObject);
begin
  InsertTags('ul');
end;

procedure TRejbrandTextEditor.InsertTags(const TagName: string);
begin
  Editor.SurroundText('<' + TagName + '>', '</' + TagName + '>');
end;

procedure TRejbrandTextEditor.InsertTag(const TagName: string);
begin
  Editor.SelText := '<' + TagName + ' />';
end;

procedure TRejbrandTextEditor.aInsertCharByDescriptionSearchExecute(Sender: TObject);
begin
  if not chrFrm.Visible then
    aInsertChar.Execute;
  chrFrm.Searchforstring1.Click;
end;

procedure TRejbrandTextEditor.aInsertCharExecute(Sender: TObject);
begin

  if FFirstTimeChrDlg then
  begin
    if (WindowState = wsNormal) and (Left + Width + chrFrm.Width <= Screen.DesktopWidth) then
    begin
      chrFrm.Top := Top + Height - chrFrm.Height;
      chrFrm.Left := Left + Width;
    end
    else if WindowState = wsMaximized then
    begin
      chrFrm.Top := Top + Height - chrFrm.Height - IfThen(StatusBar.Visible, StatusBar.Height) - GetSystemMetrics(SM_CYFRAME) - 16;
      chrFrm.Left := Left + Width - chrFrm.Width - 16;
    end;
  end;

  chrFrm.Show;

  if chrFrm.CanFocus then
    chrFrm.SetFocus;

  FFirstTimeChrDlg := false;
end;

procedure TRejbrandTextEditor.aInsertColorExecute(Sender: TObject);
begin
  with ColorDialog.TColorDialog.Create(nil) do
    try
      if (Editor.SelLength = 7) and (Editor.SelText[1] = '#') then
        ColorAsHex := Editor.SelText;
      if Execute then
        Editor.SelText := ColorAsHex;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aInvertCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_INVERT_CASE);
end;

procedure TRejbrandTextEditor.aInvertCaseUpdate(Sender: TObject);
begin
  aInvertCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_INVERT_CASE);
end;

procedure TRejbrandTextEditor.aItCircledExecute(Sender: TObject);
begin
  Editor.InputTransform := itCircled;
end;

procedure TRejbrandTextEditor.aItCircledUpdate(Sender: TObject);
begin
  aItCircled.Checked := Editor.InputTransform = itCircled;
end;

procedure TRejbrandTextEditor.aItDoublyCircledExecute(Sender: TObject);
begin
  Editor.InputTransform := itDoublyCircled;
end;

procedure TRejbrandTextEditor.aItDoublyCircledUpdate(Sender: TObject);
begin
  aItDoublyCircled.Checked := Editor.InputTransform = itDoublyCircled;
end;

procedure TRejbrandTextEditor.aItLowerCaseExecute(Sender: TObject);
begin
  Editor.InputTransform := itLowerCase;
end;

procedure TRejbrandTextEditor.aItLowerCaseUpdate(Sender: TObject);
begin
  aItLowerCase.Checked := Editor.InputTransform = itLowerCase;
end;

procedure TRejbrandTextEditor.aItNoneExecute(Sender: TObject);
begin
  Editor.InputTransform := itNone;
end;

procedure TRejbrandTextEditor.aItNoneUpdate(Sender: TObject);
begin
  aItNone.Checked := Editor.InputTransform = itNone;
end;

procedure TRejbrandTextEditor.aItParenthesizedExecute(Sender: TObject);
begin
  Editor.InputTransform := itParenthesized;
end;

procedure TRejbrandTextEditor.aItParenthesizedUpdate(Sender: TObject);
begin
  aItParenthesized.Checked := Editor.InputTransform = itParenthesized;
end;

procedure TRejbrandTextEditor.aItSubscriptExecute(Sender: TObject);
begin
  Editor.InputTransform := itSubscript;
end;

procedure TRejbrandTextEditor.aItSubscriptUpdate(Sender: TObject);
begin
  aItSubscript.Checked := Editor.InputTransform = itSubscript;
end;

procedure TRejbrandTextEditor.aItSuperscriptExecute(Sender: TObject);
begin
  Editor.InputTransform := itSuperscript;
end;

procedure TRejbrandTextEditor.aItSuperscriptUpdate(Sender: TObject);
begin
  aItSuperscript.Checked := Editor.InputTransform = itSuperscript;
end;

procedure TRejbrandTextEditor.aItUpperCaseExecute(Sender: TObject);
begin
  Editor.InputTransform := itUpperCase;
end;

procedure TRejbrandTextEditor.aItUpperCaseUpdate(Sender: TObject);
begin
  aItUpperCase.Checked := Editor.InputTransform = itUpperCase;
end;

const
  LoremIpsum: array[0..3] of string = ('Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. ',
    'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. ',
    'Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. ',
    'Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum. ');

procedure TRejbrandTextEditor.aLoremIpsumExecute(Sender: TObject);
var
  N: integer;
  S: string;
  i: Integer;
begin
  N := 4;
  S := '';
  if TMultiInputBox.NumInputBox(Self, 'Lorem Ipsum', 'Please enter the number of sentences to insert:', N, 1, 1024) then
  begin
    for i := 0 to N - 1 do
      S := S + LoremIpsum[i mod 4];
    Editor.SelText := S;
  end;
end;

procedure TRejbrandTextEditor.aLowerCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_LOWER_CASE);
end;

procedure TRejbrandTextEditor.aLowerCaseUpdate(Sender: TObject);
begin
  aLowerCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_LOWER_CASE);
end;

procedure TRejbrandTextEditor.aMakeUniqueExecute(Sender: TObject);
begin
  Editor.MakeLinesUnique;
end;

procedure TRejbrandTextEditor.aMakeUniqueUpdate(Sender: TObject);
begin
  aMakeUnique.Enabled := Editor.LineCount > 1;
end;

procedure TRejbrandTextEditor.aNewExecute(Sender: TObject);
begin
  NewFile;
end;

procedure TRejbrandTextEditor.aNewWindowExecute(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(Application.ExeName), nil, nil, SW_SHOWNORMAL);
end;

procedure TRejbrandTextEditor.aNextTabExecute(Sender: TObject);
begin
  if TabList.Items.Count > 0 then
    GotoFile((ActiveFileIndex + 1) mod TabList.Items.Count);
end;

procedure TRejbrandTextEditor.aNextTabUpdate(Sender: TObject);
begin
  aNextTab.Enabled := TabList.Items.Count > 1;
end;

procedure TRejbrandTextEditor.aNotificationWindowExecute(Sender: TObject);
begin
  notificationsFrm.Visible := not notificationsFrm.Visible;
  if notificationsFrm.Visible then
    UpdateNotificationsWindow;
end;

procedure TRejbrandTextEditor.aNotificationWindowUpdate(Sender: TObject);
begin
  aNotificationWindow.Checked := notificationsFrm.Visible;
end;

function GetFileSizeEx(AFile: THandle; var AFileSize: TLargeInteger): BOOL; stdcall; external kernel32;

function GetFileSize(const AFileName: TFileName): Int64;
var
  F: THandle;
  S: TLargeInteger;
begin

  result := -1;

  F := CreateFile(PChar(AFileName), GENERIC_READ,
    FILE_SHARE_READ or FILE_SHARE_WRITE, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);

  if F = INVALID_HANDLE_VALUE then Exit;

  if GetFileSizeEx(F, S) then
    result := S;

  CloseHandle(F);

end;



procedure TRejbrandTextEditor.LoadFile(const AFileName: TFileName; AReadOnly: boolean);
var
  hresult: boolean;
  PositiveEncoding: TTextEncoding;
  PossibleEncodings: TTextEncodings;
  MagicWordsFound: TTextEncodings;
begin

  try

    if not FileExists(AFileName) then
    begin
      ShowErrorMessage(Format('Couldn''t find file "%s".', [AFileName]));
      Exit;
    end;

    if GetFileSize(AFileName) > FILE_SIZE_LIMIT then
    begin
      ShowErrorMessage('The file is too big to load.');
      Exit;
    end;

    hresult := GuessEncodingOfFile(AFileName, PositiveEncoding, PossibleEncodings, MagicWordsFound);
    if hresult then
    begin
      SetLength(FTextFiles, Length(FTextFiles) + 1);
      FTextFiles[high(FTextFiles)] := TTextFile.Create;
      Screen.Cursor := crHourGlass;
      try
        FTextFiles[high(FTextFiles)].LoadFromFileAndInitUndo(AFileName, GetVCLEncoding(PositiveEncoding));
      finally
        Screen.Cursor := crDefault;
      end;
    end
    else
      with TselEncFrm.Create(nil) do
        try
          FFileName := AFileName;
          FPossibleEncodings := PossibleEncodings;
          FProbableEncoding := PositiveEncoding;
          if ShowModal = mrOk then
          begin
            SetLength(FTextFiles, Length(FTextFiles) + 1);
            FTextFiles[high(FTextFiles)] := TTextFile.Create;
            Screen.Cursor := crHourGlass;
            try
              FTextFiles[high(FTextFiles)].LoadFromFileAndInitUndo(AFileName, GetVCLEncoding(FSelectedEncoding));
            finally
              Screen.Cursor := crDefault;
            end;
          end
          else
            Exit;
        finally
          Free;
        end;

    FTextFiles[high(FTextFiles)].Encoding.SetHasMagicWord(MagicWordsFound);
    UpdateTabs;
    GotoFile(high(FTextFiles));
    ApplyAssocFormattingProcessor;

    if AReadOnly then
      Editor.EditMode := emReadOnly
    else
      ApplyAssocReadOnlyMode;

  except
    on E: EFOpenError do
      ShowErrorMessage(E.Message);
  end;

end;

procedure TRejbrandTextEditor.LoadFiles(const AFileNames: array of string);
var
  FileName: TFileName;
begin
  for FileName in AFileNames do
    LoadFile(FileName);
end;

procedure TRejbrandTextEditor.LoadRTEFile(const AFileName: TFileName);
begin

  if not FileExists(AFileName) then
  begin
    ShowErrorMessage(Format('Couldn''t find file "%s".', [AFileName]));
    Exit;
  end;

  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].LoadFromFile(AFileName, TEncoding.UTF8, true);
  FTextFiles[high(FTextFiles)].EditMode := emReadOnly;
  FTextFiles[high(FTextFiles)].StrictReadOnly := true;
  FTextFiles[high(FTextFiles)].UseLineClasses := true;
  with FTextFiles[high(FTextFiles)].EditorState do
  begin
    Valid := true;
    MultiSize := true;
    RulerVisible := false;
  end;

  Editor.LoadDefaultClasses;

  UpdateTabs;
  GotoFile(high(FTextFiles));

end;

const
  CTL_MNU_OPEN = 100;
  CTL_MNU_OPEN_OPEN = 101;
  CTL_MNU_OPEN_READONLY = 102;

procedure TRejbrandTextEditor.OpenDialogExecute(Sender: TObject);
var
  FDC: IFileDialogCustomize;
begin

  if (Sender is TFileOpenDialog) and
    (TFileOpenDialog(Sender).Dialog.QueryInterface(IID_IFileDialogCustomize, FDC) = S_OK) then
  begin

    if FDC.EnableOpenDropDown(CTL_MNU_OPEN) = S_OK then
    begin
      FDC.AddControlItem(CTL_MNU_OPEN, CTL_MNU_OPEN_OPEN, 'Open');
      FDC.AddControlItem(CTL_MNU_OPEN, CTL_MNU_OPEN_READONLY, 'Open (read-only)');
    end;

  end;

end;

procedure TRejbrandTextEditor.OpenDialogOkClick(Sender: TObject; var CanClose: boolean);
var
  FDC: IFileDialogCustomize;
  ItemID: cardinal;
begin

  if Sender is TFileOpenDialog then
  begin

    TFileOpenDialog(Sender).Tag := CTL_MNU_OPEN_OPEN;

    if TFileOpenDialog(Sender).Dialog.QueryInterface(IID_IFileDialogCustomize, FDC) = S_OK then
    begin

      if FDC.GetSelectedControlItem(CTL_MNU_OPEN, ItemID) = S_OK then
      begin
        if ItemID = CTL_MNU_OPEN_READONLY then
          TFileOpenDialog(Sender).Tag := CTL_MNU_OPEN_READONLY
        else
          TFileOpenDialog(Sender).Tag := CTL_MNU_OPEN_OPEN;
      end;

    end;
  end;

end;

procedure TRejbrandTextEditor.aOpenExecute(Sender: TObject);
var
  fn: string;
  ExecRes: boolean;
begin

  if TOSVersion.Check(6, 0) then
  begin

    with TFileOpenDialog.Create(nil) do
      try
        Options := [fdoAllowMultiSelect, fdoPathMustExist, fdoFileMustExist];
        with FileTypes.Add do
        begin
          DisplayName := 'All files';
          FileMask := '*.*';
        end;
        OnExecute := OpenDialogExecute;
        OnFileOkClick := OpenDialogOkClick;
        Application.ModalStarted;
        try
          ExecRes := Execute;
        finally
          Application.ModalFinished;
        end;
        if ExecRes then
          for fn in Files do
            LoadFile(fn, Tag = CTL_MNU_OPEN_READONLY);
      finally
        Free;
      end;

  end

  else
  begin

    with TOpenDialog.Create(nil) do
      try
        Options := [ofAllowMultiSelect, ofPathMustExist, ofFileMustExist];
        Filter := 'All files|*.*';
        Application.ModalStarted;
        try
          ExecRes := Execute
        finally
          Application.ModalFinished;
        end;
        if ExecRes then
          for fn in Files do
            LoadFile(fn, ofReadOnly in Options);
      finally
        Free;
      end;

  end;

end;

const
  OFASI_EDIT = $0001;
  OFASI_OPENDESKTOP = $0002;

{$IFDEF UNICODE}
function ILCreateFromPath(pszPath: PChar): PItemIDList stdcall; external shell32
  name 'ILCreateFromPathW';
{$ELSE}
function ILCreateFromPath(pszPath: PChar): PItemIDList stdcall; external shell32
  name 'ILCreateFromPathA';
{$ENDIF}
procedure ILFree(pidl: PItemIDList) stdcall; external shell32;
function SHOpenFolderAndSelectItems(pidlFolder: PItemIDList; cidl: Cardinal;
  apidl: pointer; dwFlags: DWORD): HRESULT; stdcall; external shell32;

procedure TRejbrandTextEditor.aOpenFolderExecute(Sender: TObject);
var
  IIDL: PItemIDList;
begin

  if not FileExists(Editor.TextFile.FileName) then
    Exit;

  IIDL := ILCreateFromPath(PChar(Editor.TextFile.FileName));
  if IIDL <> nil then
    try
      if SHOpenFolderAndSelectItems(IIDL, 0, nil, 0) <> S_OK then
        ShellExecute(Handle, nil, PChar(ExtractFilePath(Editor.TextFile.FileName)),
          nil, nil, SW_SHOWNORMAL);
    finally
      ILFree(IIDL);
    end;

end;

procedure TRejbrandTextEditor.aOpenFolderUpdate(Sender: TObject);
begin
  aOpenFolder.Enabled := FileExists(Editor.TextFile.FileName);
end;

procedure TRejbrandTextEditor.aPasteAsExecute(Sender: TObject);
begin
  with TpasteAsFrm.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aPasteAsUpdate(Sender: TObject);
begin
  aPasteAs.Enabled := Editor.Focused and Clipboard.HasFormat(CF_TEXT);
end;

procedure TRejbrandTextEditor.aPasteExecute(Sender: TObject);
begin
  if Editor.Focused then
    Editor.PasteFromClipboard
  else if Assigned(Screen.ActiveControl) then
    Screen.ActiveControl.Perform(WM_PASTE, 0, 0);
end;

procedure TRejbrandTextEditor.aPasteUpdate(Sender: TObject);
begin
  aPaste.Enabled := Clipboard.HasFormat(CF_TEXT)
    and
    (
      Editor.Focused
      or
      (Screen.ActiveControl is TCustomEdit)
    )
end;

procedure TRejbrandTextEditor.aPerformWordWrapExecute(Sender: TObject);
begin
  with TwwpFrm.Create(nil) do
    try
      if ShowModal = mrOk then
        if rbN.Checked then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, #0)
        else if rbA.Checked then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, rbA.Caption[1])
        else if (rbC.Checked and (Length(eC.Text) > 0)) then
          Editor.WordWrap(StrToInt(eL.Text), cbS.Checked, eC.Text[1]);
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aPerformWordWrapUpdate(Sender: TObject);
begin
  aPerformWordWrap.Enabled := not Editor.TextFile.Empty;
end;

procedure TRejbrandTextEditor.aPrevTabExecute(Sender: TObject);
begin
  if ActiveFileIndex > 0 then
    GotoFile(ActiveFileIndex - 1)
  else
    GotoFile(TabList.Items.Count - 1);
end;

procedure TRejbrandTextEditor.aPrevTabUpdate(Sender: TObject);
begin
  aPrevTab.Enabled := TabList.Items.Count > 1;
end;

procedure TRejbrandTextEditor.aPrinterSetupExecute(Sender: TObject);
begin
  with TPrinterSetupDialog.Create(nil) do
    try
      Execute
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aPrintExecute(Sender: TObject);
begin
  with TPrintDialog.Create(nil) do
    try
      if Editor.TextFile.HasSelection then
        Options := [poSelection];
      if Execute then
        if PrintRange = prSelection then
          Editor.PrintSelection
        else
          Editor.Print
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aReadOnlyExecute(Sender: TObject);
begin
  if Editor.EditMode = emReadOnly then
    Editor.EditMode := emText
  else
    Editor.EditMode := emReadOnly;
end;

procedure TRejbrandTextEditor.aReadOnlyUpdate(Sender: TObject);
begin
  aReadOnly.Checked := Editor.EditMode = emReadOnly;
  aReadOnly.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SET_EDIT_MODE);
end;

procedure TRejbrandTextEditor.aRedoExecute(Sender: TObject);
begin
  Editor.Redo;
end;

procedure TRejbrandTextEditor.aRedoUpdate(Sender: TObject);
begin
  aRedo.Enabled := Editor.Focused and Editor.CanRedo;
end;

procedure TRejbrandTextEditor.aRemoveIndentExecute(Sender: TObject);
begin
  Editor.RemoveIndent;
end;

procedure TRejbrandTextEditor.aReplaceExecute(Sender: TObject);
begin
  replaceFrm.rbSelection.Enabled := Editor.TextFile.HasSelection;
  if replaceFrm.rbSelection.Enabled then
    replaceFrm.rbSelection.Checked := true
  else
    replaceFrm.rbEntireFile.Checked := true;
  replaceFrm.Show;
  if replaceFrm.eSearch.CanFocus then
    replaceFrm.eSearch.SetFocus;
end;

procedure TRejbrandTextEditor.aRestoreSettingsExecute(Sender: TObject);
begin

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := 'Do you want to restore all application settings to their default values?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Restore';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              RestoreDefaultSettings;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to restore all application settings to their default values?',
        PChar(Application.Title),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        RestoreDefaultSettings;
    end;

end;

procedure TRejbrandTextEditor.aReverseTextExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_REVERSE);
end;

procedure TRejbrandTextEditor.aReverseTextUpdate(Sender: TObject);
begin
  aReverseText.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_REVERSE);
end;

procedure TRejbrandTextEditor.aRevertExecute(Sender: TObject);
begin

  if not FileExists(Editor.TextFile.FileName) then
    Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to reload the file from the file system?';
        FooterText := 'This contents of the current editor buffer will be lost unless it is identical to the current data in the file system file. This operation cannot be undone.';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Reload';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              begin
                Screen.Cursor := crHourGlass;
                try
                  Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
                finally
                  Screen.Cursor := crDefault;
                end;
              end;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to reload the file from the file system? The contents of the current editor buffer will be lost and the operation cannot be undone.',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        begin
          Screen.Cursor := crHourGlass;
          try
            Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
          finally
            Screen.Cursor := crDefault;
          end;
        end;
    end;

  UpdateTabs;
  SetWindowCaption;

end;

procedure TRejbrandTextEditor.aRevertUpdate(Sender: TObject);
begin
  aRevert.Enabled := FileExists(Editor.TextFile.FileName);
end;

procedure TRejbrandTextEditor.aROT13Execute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_ROT13);
end;

procedure TRejbrandTextEditor.aROT13Update(Sender: TObject);
begin
  aROT13.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_ROT13);
end;

procedure TRejbrandTextEditor.aRowHighlightExecute(Sender: TObject);
begin
  Editor.LineHighlight := not Editor.LineHighlight;
end;

procedure TRejbrandTextEditor.aRowHighlightUpdate(Sender: TObject);
begin
  aRowHighlight.Checked := Editor.LineHighlight;
end;

procedure TRejbrandTextEditor.aRulerExecute(Sender: TObject);
begin
  aRuler.Checked := not aRuler.Checked;
  Editor.RulerVisible := aRuler.Checked;
end;

procedure TRejbrandTextEditor.aRulerUpdate(Sender: TObject);
begin
  aRuler.Checked := Editor.RulerVisible;
end;

procedure TRejbrandTextEditor.aSaveAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to high(FTextFiles) do
    if (not SaveFile(i)) and (i < high(FTextFiles)) and
      (MessageBox(Handle, 'Continue save all operation?', 'Save all', MB_ICONQUESTION or MB_YESNO) = ID_NO) then
      break;
end;

procedure TRejbrandTextEditor.aSaveAsExecute(Sender: TObject);
begin
  SaveFileAs(ActiveFileIndex);
end;

procedure TRejbrandTextEditor.aSaveAsUpdate(Sender: TObject);
begin
  aSaveAs.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SAVE);
end;

procedure TRejbrandTextEditor.aSaveExecute(Sender: TObject);
begin
  SaveFile(ActiveFileIndex);
end;

procedure TRejbrandTextEditor.aSaveUpdate(Sender: TObject);
begin
  aSave.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SAVE);
end;

procedure TRejbrandTextEditor.aSelectAllExecute(Sender: TObject);
begin
  if Editor.Focused then
    Editor.SelectAllNone
  else if Screen.ActiveControl is TCustomEdit then
    TCustomEdit(Screen.ActiveControl).SelectAll;
end;

procedure TRejbrandTextEditor.aSelectAllUpdate(Sender: TObject);
begin
  if Editor.Focused then
  begin
    aSelectAll.Enabled := Editor.Focused and not Editor.TextFile.Empty;
    if Editor.TextFile.AllSelected and not Editor.TextFile.Empty then
      aSelectAll.Caption := 'Select nothing'
    else
      aSelectAll.Caption := 'Select all';
  end
  else
  begin
    aSelectAll.Enabled := Screen.ActiveControl is TCustomEdit;
    aSelectAll.Caption := 'Select all';
  end;
end;

procedure TRejbrandTextEditor.aSelectionToNewBufferExecute(Sender: TObject);
begin
  NewBufferWithContents(Editor.SelText);
end;

procedure TRejbrandTextEditor.aSelectionToNewBufferUpdate(Sender: TObject);
begin
  aSelectionToNewBuffer.Enabled := Editor.TextFile.HasSelection;
end;

procedure TRejbrandTextEditor.aSelectLineExecute(Sender: TObject);
begin
  Editor.SelectLine;
end;

procedure TRejbrandTextEditor.aSelectLineUpdate(Sender: TObject);
begin
  aSelectLine.Enabled := Editor.Focused and
    (Editor.TextFile.PhysicalLineWidths[Editor.CaretPos.Y] > 0);
end;

procedure TRejbrandTextEditor.aSelectWordExecute(Sender: TObject);
begin
  Editor.SelectWord;
end;

procedure TRejbrandTextEditor.aSelectWordUpdate(Sender: TObject);
begin
  aSelectWord.Enabled := Editor.Focused and (Editor.GetWord <> '');
end;

procedure TRejbrandTextEditor.aSentenceCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_SENTENCE_CASE);
end;

procedure TRejbrandTextEditor.aSentenceCaseUpdate(Sender: TObject);
begin
  aSentenceCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_SENTENCE_CASE);
end;

procedure TRejbrandTextEditor.aSetBgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.BackgroundColor;
  if SelectColor(c) then
    Editor.BackgroundColor := c;
end;

procedure TRejbrandTextEditor.aSetBgColorUpdate(Sender: TObject);
begin
  aSetBgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aSetBracketHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.BracketHighlightColor;
  if SelectColor(c) then
    Editor.BracketHighlightColor := c;
end;

procedure TRejbrandTextEditor.aSetFPAssocExecute(Sender: TObject);
begin
  ShowSettingsDialog(2);
end;

procedure TRejbrandTextEditor.aSetRowHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.LineHighlightColor;
  if SelectColor(c) then
    Editor.LineHighlightColor := c;
end;

procedure TRejbrandTextEditor.aSetRulerBackgroundColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.RulerColor;
  if SelectColor(c) then
    Editor.RulerColor := c;
end;

procedure TRejbrandTextEditor.aSetRulerTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.RulerFont.Color;
  if SelectColor(c) then
    Editor.RulerFont.Color := c;
end;

procedure TRejbrandTextEditor.aSetSearchHighlightColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.FindBackgroundColor;
  if SelectColor(c) then
    Editor.FindBackgroundColor := c;
end;

procedure TRejbrandTextEditor.aSetSearchHighlightTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.FindForegroundColor;
  if SelectColor(c) then
    Editor.FindForegroundColor := c;
end;

procedure TRejbrandTextEditor.aSetSelBgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.SelBackgroundColor;
  if SelectColor(c) then
    Editor.SelBackgroundColor := c;
end;

procedure TRejbrandTextEditor.aSetSelBgColorUpdate(Sender: TObject);
begin
  aSetSelBgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aSetSelFgColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.SelForegroundColor;
  if SelectColor(c) then
    Editor.SelForegroundColor := c;
end;

procedure TRejbrandTextEditor.aSetSelFgColorUpdate(Sender: TObject);
begin
  aSetSelFgColor.Enabled := not Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aSetTabLengthExecute(Sender: TObject);
var
  v: integer;
begin
  v := Editor.TabLength;
  if TMultiInputBox.NumInputBox(Self, 'Tab length', 'Please enter the tab length:', v, 0, 1024) then
    Editor.TabLength := v;
end;

procedure TRejbrandTextEditor.aSetTextColorExecute(Sender: TObject);
var
  c: TColor;
begin
  c := Editor.ForegroundColor;
  if SelectColor(c) then
    Editor.ForegroundColor := c;
end;

procedure TRejbrandTextEditor.aSetTextColorUpdate(Sender: TObject);
begin
  aSetTextColor.Enabled := not Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aSettingsExecute(Sender: TObject);
begin
  ShowSettingsDialog;
end;

procedure TRejbrandTextEditor.aShellExecuteFileExecute(Sender: TObject);
begin
  if FileExists(Editor.TextFile.FileName) then
    ShellExecute(Handle, nil, PChar(Editor.TextFile.FileName), nil, nil, SW_SHOWNORMAL);
end;

procedure TRejbrandTextEditor.aShellExecuteFileUpdate(Sender: TObject);
begin
  aShellExecuteFile.Enabled := FileExists(Editor.TextFile.FileName);
end;

procedure TRejbrandTextEditor.aShowAutoReplaceListExecute(Sender: TObject);
var
  i: integer;
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;

  with FTextFiles[high(FTextFiles)] do
  begin
    NewFile;
    InsertLine('Auto-replace codes', 'Heading 2', 0);
    BeginAddLine;
    for i := 0 to AutoReplaceItemCount - 1 do
      with AutoReplaceItems[i] do
        AddLine(Token + ': ' + ReplacedValue);
    EndAddLine;
    EditMode := emReadOnly;
    StrictReadOnly := true;
    UseLineClasses := true;
    FileModified := false;
    FileName := 'Auto-replace codes';
    GotoSOF;
    with EditorState do
    begin
      Valid := true;
      MultiSize := true;
    end;
  end;

  UpdateTabs;
  Editor.LoadDefaultClasses;
  GotoFile(high(FTextFiles));
  Editor.MakeUndoRoot;
end;

function LineComparerStrLen(const A, B: string): integer;
begin
  result := CompareValue(Length(A), Length(B));
end;

function LineComparerIntegers(const A, B: string): integer;
var
  Ai, Bi: Int64;
begin
  result := 0;
  if TryStrToInt64(A, Ai) and TryStrToInt64(B, Bi) then
    result := CompareValue(Ai, Bi);
end;

function LineComparerReals(const A, B: string): integer;
var
  Ar, Br: extended;
begin
  result := 0;
  if TryStrToFloat(A, Ar) and TryStrToFloat(B, Br) then
    result := CompareValue(Ar, Br);
end;

procedure TRejbrandTextEditor.aSortLinesExecute(Sender: TObject);
begin
  with TsortFrm.Create(nil) do
    try
      cbComparer.ItemIndex := 0;
      rbSelection.Enabled := Editor.TextFile.HasSelection;
      if rbSelection.Enabled then
        rbSelection.Checked := true
      else
        rbEntireFile.Checked := true;
      if ShowModal = mrOk then
      begin
        case cbComparer.ItemIndex of
          0:
            Editor.LineComparer := AnsiCompareText;
          1:
            Editor.LineComparer := AnsiCompareStr;
          2:
            Editor.LineComparer := LineComparerStrLen;
          3:
            Editor.LineComparer := LineComparerIntegers;
          4:
            Editor.LineComparer := LineComparerReals;
        else
          Editor.LineComparer := nil;
        end;
        Editor.SortReverseOrder := cbReverse.Checked;
        Screen.Cursor := crHourGlass;
        try
          if rbSelection.Checked then
            Editor.SortSelection
          else
            Editor.Sort;
        finally
          Screen.Cursor := crDefault;
        end;
      end;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aSortLinesUpdate(Sender: TObject);
begin
  aSortLines.Enabled := Editor.LineCount > 1;
end;

procedure TRejbrandTextEditor.aStatisticsExecute(Sender: TObject);
begin
  with TstatisticsFrm.Create(nil) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aStatusBarExecute(Sender: TObject);
begin
  aStatusBar.Checked := not aStatusBar.Checked;
  StatusBar.Visible := aStatusBar.Checked;
end;

procedure TRejbrandTextEditor.aStatusBarUpdate(Sender: TObject);
begin
  aStatusbar.Checked := StatusBar.Visible;
end;

procedure TRejbrandTextEditor.aStatusMsgCopyExecute(Sender: TObject);
begin
  Clipboard.AsText := Statusbar.Panels[STATUS_MESSAGE].Text;
end;

const
  TipsOfTheDays: array[0..54] of string = (
    'To insert the Unicode character with codepoint U+ABCD, simply write ABCD and press Ctrl+U (like Alt+X in Microsoft Word).',
    'Press Ctrl+D to delete the current line.',
    'Press Shift+Ctrl+Arrow Up/Down to move the current line up or down in the document.',
    'Press Shift+Ctrl+A to select the current word.',
    'Press Ctrl+L to select the current line.',
    'Using the Paste As dialog box (Shift+Ctrl+V), you can easily paste a block of text as an HTML ordered or unordered list, for example.',
    'Text files can be dragged to an editor window from the Windows Explorer. You can drag a selection of several files; each file will then be opened in a new editor tab.',
    'Pressing Ctrl+C (Copy) when there is no selection will automatically copy the current word to clipboard. ("The current word" refers to the word in which the caret is positioned at the moment.) You get a visual indication of this.',
    'Hold down the Control key and use the scroll wheel to zoom in and out in the document.',
    'Hold down the Alt key and use the scroll wheel to move up and down in the document, as you do with the up and down arrow keys.',
    'Hold down the Shift key while scrolling using the mouse wheel to scroll smoothly, one pixel at a time.',
    'Hold down the Alt key and drag using the mouse to pan the document. When the Alt key is down, you can also change the scroll pos using the keyboard''s arrow keys. When the Scroll Lock key is on, this scrolling behaviour is present even without the Alt key.',
    'You can use the Pause key on the keyboard to toggle Read-Only mode on/off.',
    'Pressing Ctrl+A twice will undo the Select All operation, and select nothing.',
    'Using the Block Paste feature (Shift+Ctrl+Alt+V) you can paste a block of text as a block of text with its top-left corner at the caret, overwriting present characters, if any.',
    'Using the Truncate At feature (Edit/Truncate at...), you can truncate all lines in the document or in the current selection at a fixed character column or at the Nth occurrence of a given character on the line,'+' counting from the beginning or from the end of line.',
    'Using the Filter Lines feature (Edit/Filter lines...), you can remove all lines in the document that contain (start with, end with) or do not contain (start with, end with) a particular string.',
    'You can toggle the Caret beyond end of line (EOL) feature on and off by pressing Shift+Ctrl+Alt+C.',
    'When opening a text file in Rejbrand Text Editor, the application will try to determine the encoding of the file.'#13#10#13#10 + 'In most cases, the application will guess the correct encoding and simply open '+'the file. If the encoding cannot be positively determined, a dialog box will '+'ask you for the encoding to use; the most probable candidate is selected by default, and you can preview the text in different encodings '+'before opening the file.'#13#10#13#10 + 'If the file is still opened using an inappropriate encoding, you can select a new encoding from the Encoding menu. If you choose a new encoding '+'immediately after the file has been opened, Rejbrand Text Editor will ask you if you want to reopen the file using the newly specified encoding.',
    'When you have inserted the hyphen-minus character (-) in the text, you may press F9 to display a dialog box with different kinds of hyphens, minus signs, and dashes: hyphens of different line-breaking types, '+'the minus sign, EN dash, EM dash, and so on. The character you select will replace the hyphen-minus.',
    'When you have inserted the asterisk character (*) in the text, you may press F9 to display a dialog box with different kinds of asterisks, bullets, and points, such as typographical bullets and mathematical '+'operators for multiplication and other binary operations. The character you select will replace the asterisk.',
    'When you have inserted a single or double quotation mark in the text, you may press F9 to display a dialog box with other kinds of (single or double) quotation marks, including typographical quotation marks in English, German, and Swedish.',
    'By pressing Shift+Ctrl+N, where N is a digit between 1 and 9, you set a bookmark at the caret location. Later, you can go to this location by pressing Ctrl+N.',
    'You can show or hide the ruler by pressing F4.',
    'Press F5 to insert the current date and time at the caret.',
    'Rejbrand Text Editor allows rapid insertion of many (X)HTML tags. See the Insert/(X)HTML menu for the options, and their associated shortcuts.',
    'The Unicode codepoint and description of the character at the caret (to the right of the caret), the currently selected character, or the newly typed character, '+'is shown in the status bar. You can double-click this status bar panel to copy its text to the clipboard (or, press Shift+F7).',
    'When writing text in English, make sure not to confuse "its" (possessive) with "it''s" (="it is", "it has").',
    'You can press Shift+Ctrl+O to revert a document to the last saved version of it (that is, the current buffer will be discarded and the document reloaded from the file).',
    'You can use File/Delete file to remove the current document''s file from the file system. The text will still be available in the buffer, but not associated with any file on the disk.',
    'You can press Ctrl+F9 to open the current file using the Windows shell. For instance, if you edit an HTML document saved to a file, pressing Ctrl+F9 is likely to open the (saved version of the) file in your default web browser.',
    'You can press Shift+Ctrl+F9 to open the folder (using Windows Explorer) containing the current file (if the current document is saved to a file).',
    'To search the document, press Ctrl+F (for "find") and enter the search phrase. The matches will be highlighted in the text, and you can navigate between them using F2 (previous match) and F3 (next match). '+'Press Esc to close the search bar and set focus to the editor again; you can continue to use F2 and F3 until you modify the text in the editor.',
    'To export the current document to an (X)HTML document, use File/Export to HTML or press Shift+Ctrl+Alt+X. The HTML file will contain all formatting of the text (line classes and interactive formatting/syntax highlighting).',
    'Pressing the middle mouse button (scroll-wheel button) on a tab will close the tab (as in all decent software).',
    'Most contemporary Windows text editors offer multi-step undo. But most of these share the established Windows multi-undo model, which has a major flaw: '+'if you undo a number of steps, to history version X of the file, say, and then modify the file, the undo history is truncated at X, so all history versions after X are lost (you cannot "redo" these).'#13#10#13#10 + 'This is dangerous, for instance, if you undo a large number of steps to recover a string you want to copy to the clipboard with the intention of redoing all steps immediately afterwards. '+'If you accidently make an edit to the file before or after you copy the string (say, by slipping and pressing C instead of Ctrl+C), all changes you made to the file after the restored version are permanently lost.'#13#10#13#10 +
      'In Rejbrand Text Editor, this "flaw" doesn''t exist: instead, when you make an edit and you are not at the end of the history stack, the old, restored, version is copied to the end of the stack, and no version in the history is deleted.',
    'You can press Shift+Ctrl+Z to show the revision history (undo history) of the file. You can also go back and forth in time using this dialog box.',
    'An asterisk (*) next to a file name indicates that the document has been modified; that is, the version in the editor buffer differs from the file on the disk (if any).',
    'Press F8 to quickly search the Unicode database for a character.',
    'You can start Rejbrand Text Editor by running (Windows key + R) "rteditor".',
    'Pressing Ctrl+E will highlight all instances of the current word in the document. ("The current word" refers to the word in which the caret is positioned at the moment.) Pressing Ctrl+E again will remove this highlighting.'#13#10#13#10 + 'When such highlighting is active, you can navigate to each instance of the word using F2 (previous) and F3 (next).'#13#10#13#10'Shift+Ctrl+E works just like Ctrl+E, but will also accept the underscore character (_) as a part of a "word".',
    'Shift+Ctrl+N will create a new Rejbrand Text Editor window.',
    'Pressing the Home key will move the caret (or extend the selection) to the first character on the current line. Pressing Home again will move the caret (or extend the selection) to the first non-whitespace character on the line.',
    'You can select multiple files in the Open dialog box. Each selected file will open in a new tab.',
    'In the Open dialog, you can press the arrow next to the "Open" button and select "Open (read only)" to open the selected file(s) in read-only mode.',
    'You can move keyboard focus between the editor and the tab list using the F6 key. If the tab list isn''t visible '+'(because there is only a single tab in the window), it will temporarily become visible.'#13#10#13#10'When the tab has focus, you can press the Menu key to access the tab''s context menu.',
    'Pressing Ctrl+F6 will detach the current tab (file) from its window and place it in a brand new Rejbrand Text Editor window.',
    'The context menu of a tab contains an option to copy the tab''s file name to clipboard. (If the current window has only a single file opened, the tab list is invisible but can be shown using the F6 key.)',
    'You can navigate between tabs by pressing Ctrl+PgDn and Ctrl+PgUp, in addition to the usual Ctrl+Tab and Shift+Ctrl+Tab combinations.',
    'Rejbrand Text Editor supports OLE drag and drop between compatible Microsoft Windows applications (such as the Microsoft Office applications and web browsers).',
    'The Tab key inserts N spaces (U+0020: SPACE). To insert an actual horizontal tab character (U+0009: CHARACTER TABULATION), press Ctrl+J.',
    'You can drag and drop tabs to reorder them. You can even drag a tab to a different Rejbrand Text Editor window.',
    'Pressing Ctrl+Up or Ctrl+Down will create new carets on neighbouring lines. New input will be written to all these caret locations. Press Esc to exit multi-caret mode.',
    'The Find/"Character search" feature lets you search for Unicode characters based on Unicode block.',
    'Try writing \alpha, \int, \approx, \in, \sum, \union, \deg, and \snowman in the editor. To see the complete list of recognised codes, press Shift+F1.'#13#10#13#10'You can change the list of recognised codes using the AutoReplace Editor on the Start menu.');

procedure TRejbrandTextEditor.TipOfTheDayVerificationClicked(Sender: TObject);
begin
  FAutoTip := not FAutoTip;
end;

procedure TRejbrandTextEditor.aTipOfTheDayExecute(Sender: TObject);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'Rejbrand Text Editor';
        Title := 'Tip of the day';
        CommonButtons := [tcbClose];
        Text := TipsOfTheDays[Random(length(TipsOfTheDays))];
        with Buttons.Add do
        begin
          Caption := '&Another tip';
          ModalResult := mrRetry;
          Default := true;
        end;
        Flags := [tfUseHiconMain, tfAllowDialogCancellation];
        CustomMainIcon := Application.Icon;
        ExpandButtonCaption := 'Options';
        VerificationText := '&Show automatically on startup.';
        OnVerificationClicked := TipOfTheDayVerificationClicked;
        if FAutoTip then
          Flags := Flags + [tfVerificationFlagChecked];
        if ExecuteModally and (ModalResult = mrRetry) then aTipOfTheDay.Execute;
      finally
        Free;
      end
  else
    // Windows XP Compatibility Code
    MessageBox(Handle, PChar(TipsOfTheDays[Random(length(TipsOfTheDays))]), PChar('Rejbrand Text Editor'), MB_ICONINFORMATION);
end;

procedure TRejbrandTextEditor.aToggleFocusExecute(Sender: TObject);
begin
  if Editor.Focused then
  begin
    TabList.Show;
    if TabList.Visible and TabList.CanFocus then
      TabList.SetFocus;
  end
  else if Editor.CanFocus then
    Editor.SetFocus;
end;

procedure TRejbrandTextEditor.aTrimRightExecute(Sender: TObject);
begin
  Editor.TrimRight;
end;

procedure TRejbrandTextEditor.aTruncateAtExecute(Sender: TObject);
begin
  with TtruncateFrm.Create(nil) do
    try
      if Editor.TextFile.HasSelection then
        rbSelection.Checked := true
      else
        rbEntireFile.Checked := true;

      if ShowModal = mrOk then
      begin

        if rbSelection.Checked then
        begin

          if rbColumn.Checked then
            Editor.TruncateAtInSelection(StrToInt(eColumn.Text), #0, false, cbReverse.Checked)
          else if rbSearch.Checked then
            Editor.TruncateAtInSelection(IfThen(cbDirection.ItemIndex = 1, -1, 1) * (cbOrdinal.ItemIndex + 1), eChr.Text[1], cbOffset.ItemIndex <> 0, cbReverse.Checked);

        end
        else if rbEntireFile.Checked then
        begin

          if rbColumn.Checked then
            Editor.TruncateAt(StrToInt(eColumn.Text), #0, false, cbReverse.Checked)
          else if rbSearch.Checked then
            Editor.TruncateAt(IfThen(cbDirection.ItemIndex = 1, -1, 1) * (cbOrdinal.ItemIndex + 1), eChr.Text[1], cbOffset.ItemIndex <> 0, cbReverse.Checked);

        end

      end;
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.aRemoveAllIndentExecute(Sender: TObject);
begin
  Editor.RemoveAllIndent;
end;

procedure TRejbrandTextEditor.aUndoExecute(Sender: TObject);
begin
  if Editor.Focused then
    Editor.Undo
  else if Assigned(Screen.ActiveControl) then
    Screen.ActiveControl.Perform(WM_UNDO, 0, 0);
end;

procedure TRejbrandTextEditor.aUndoUpdate(Sender: TObject);
begin
  aUndo.Enabled :=
    (Editor.Focused and Editor.CanUndo)
    or
    ((Screen.ActiveControl is TCustomEdit) and TCustomEdit(Screen.ActiveControl).CanUndo)
end;

procedure TRejbrandTextEditor.aUpperCaseExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_UPPER_CASE);
end;

procedure TRejbrandTextEditor.aUpperCaseUpdate(Sender: TObject);
begin
  aUpperCase.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_UPPER_CASE);
end;

procedure TRejbrandTextEditor.aUseSystemDefaultColorsExecute(Sender: TObject);
begin
  Editor.UseSystemColors := not Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aUseSystemDefaultColorsUpdate(Sender: TObject);
begin
  aUseSystemDefaultColors.Checked := Editor.UseSystemColors;
end;

procedure TRejbrandTextEditor.aVigenereDecryptExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_VIGENERE, 1)
end;

procedure TRejbrandTextEditor.aVigenereDecryptUpdate(Sender: TObject);
begin
  aVigenereDecrypt.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_VIGENERE);
end;

procedure TRejbrandTextEditor.aVigenereEncryptExecute(Sender: TObject);
begin
  Editor.EditorCommand(EDITOR_COMMAND_SEL_VIGENERE)
end;

procedure TRejbrandTextEditor.aVigenereEncryptUpdate(Sender: TObject);
begin
  aVigenereEncrypt.Enabled := Editor.CommandEnabled(EDITOR_COMMAND_SEL_VIGENERE);
end;

procedure TRejbrandTextEditor.cbFindMatchCaseClick(Sender: TObject);
begin
  DoInstantSearch;
end;

procedure TRejbrandTextEditor.DoInstantSearch;
var
  FQ: TFindQuery;
  n: integer;
begin
  FQ := MakeFindQuery(eFind.Text, cbFindMatchCase.Checked,
    cbFindWholeWords.Checked, cbFindNewline.Checked);
  n := Editor.Find(FQ);
  stNumMatches.Visible := Length(eFind.Text) > 0;
  if stNumMatches.Visible then
    stNumMatches.Caption := Format('%d match(es)', [n]);
end;

function TRejbrandTextEditor.DropTargetDragEnter(const dataObj: IDataObject;
  grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT;
begin
  FDragDataObj := dataObj;
  FDragCompatFmt := dataObj.QueryGetData(FORMATETC_RTABCTLTAB) = S_OK;
  if FDragCompatFmt then
    dwEffect := dwEffect and DROPEFFECT_MOVE
  else
    dwEffect := DROPEFFECT_NONE;
  result := S_OK;
end;

function TRejbrandTextEditor.DropTargetDragLeave: HRESULT;
begin
  FDragCompatFmt := false;
  FDragDataObj := nil;
  result := S_OK;
end;

function TRejbrandTextEditor.DropTargetDragOver(grfKeyState: Longint;
  pt: TPoint; var dwEffect: Longint): HRESULT;
begin
  if FDragCompatFmt then
    dwEffect := dwEffect and DROPEFFECT_MOVE
  else
    dwEffect := DROPEFFECT_NONE;
  result := S_OK;
end;

function TRejbrandTextEditor.DropTargetDrop(const dataObj: IDataObject;
  grfKeyState: Longint; pt: TPoint; var dwEffect: Longint): HRESULT;
var
  medium: TStgMedium;
  TabRec: PRTabInfo;
begin

  FDragCompatFmt := dataObj.QueryGetData(FORMATETC_RTABCTLTAB) = S_OK;
  if FDragCompatFmt then
    dwEffect := dwEffect and DROPEFFECT_MOVE
  else
    dwEffect := DROPEFFECT_NONE;

  case dwEffect of
    DROPEFFECT_MOVE:
      begin
        result := E_UNEXPECTED;
        if dataObj.GetData(FORMATETC_RTABCTLTAB, medium) = S_OK then
          try
            if medium.tymed = TYMED_HGLOBAL then
              if GlobalSize(medium.hGlobal) >= sizeof(TRTabInfo) then
              begin
                TabRec := GlobalLock(medium.hGlobal);
                if Assigned(TabRec) then
                  try
                    if TabRec.Len = sizeof(TRTabInfo) then
                    begin
                      if TabRec.Wnd = TabList.Handle then
                        result := E_UNEXPECTED
                      else
                      begin
                        // Obtain tab from other window
                        if AppendExternalTab(TabRec.Wnd, TabRec.Idx,
                          TabRec.TabName, dataObj) then
                          result := S_OK;
                      end;
                    end
                  finally
                    GlobalUnlock(medium.hGlobal);
                  end
              end
          finally
            ReleaseStgMedium(medium);
          end
      end;
    DROPEFFECT_NONE:
      result := S_OK;
  else
    result := E_UNEXPECTED;
  end;

end;

function TRejbrandTextEditor.AppendExternalTab(TabControl: HWND; TabIndex: integer;
  const TabName: string; dataObj: IDataObject): boolean;
var
  medium: TStgMedium;
  buf: pointer;
  len: UInt64;
  TF: TTextFile;
begin

  result := false;

  try

    if dataObj.GetData(FORMATETC_RTABCTLTABDATA, medium) = S_OK then
      try
        if medium.tymed = TYMED_HGLOBAL then
        begin

          buf := GlobalLock(medium.hGlobal);
          if Assigned(buf) then
            try
              len := GlobalSize(medium.hGlobal);
              TF := TTextFile.Create;
              SetLength(FTextFiles, Length(FTextFiles) + 1);
              FTextFiles[high(FTextFiles)] := TF;
              TF.LoadFromBuffer(buf, len);
              UpdateTabs;
              GotoFile(high(FTextFiles));
              result := true;
            finally
              GlobalUnlock(medium.hGlobal);
            end;

        end;
      finally
        ReleaseStgMedium(medium);
      end;

  except
    result := false;
  end;

end;

procedure TRejbrandTextEditor.EditorFindDataClear(Sender: TObject);
begin
  stNumMatches.Caption := '';
  stNumMatches.Hide;
end;

procedure TRejbrandTextEditor.EditorKeyPress(Sender: TObject; var Key: Char);
var
  DisplayKey: char;
begin
  FKeyPressed := ord(Key) > $1F;
  if Key = #$A then
    DisplayKey := #$9
  else
    DisplayKey := Key;
  StatusBarCharacterInfo(DisplayKey);
  CharacterInfo(DisplayKey);
end;

procedure TRejbrandTextEditor.EditorModified(Sender: TObject);
begin
  UpdateTabs;
  SetWindowCaption;
end;

procedure TRejbrandTextEditor.UpdateNotificationsWindow;
var
  i: integer;
begin
  if Assigned(notificationsFrm) and notificationsFrm.Visible then
    with notificationsFrm.lbNotifications do
    begin
      Items.BeginUpdate;
      Items.Clear;
      for i := 0 to Editor.NotificationCount - 1 do
        Items.Add(Editor.NotificationStr[Editor.Notifications[i]]);
      Items.EndUpdate;
    end;
end;

procedure TRejbrandTextEditor.EditorNotification(Sender: TObject; MsgID: Cardinal;
  AClear: Boolean);
begin
  UpdateNotificationsWindow;
end;

procedure TRejbrandTextEditor.EditorOverwriteChange(Sender: TObject);
begin
  StatusBar.Panels[STATUS_OVERWRITE].Text := IfThen(Editor.Overwrite, 'OVER', 'INS');
end;

procedure TRejbrandTextEditor.EditorPrintBegin(Sender: TObject; NumSteps: Integer);
begin
  TabList.Enabled := false;
  EnableWindow(TabList.Handle, false);
  FDoAbortPrinting := false;
  ActionList.State := asSuspended;
  printingFrm.stDocName.Caption := ExtractFileName(Editor.TextFile.FileName);
  printingFrm.stPrinterName.Caption := Printer.Printers[Printer.PrinterIndex];
  printingFrm.stPrintProgress.Caption := '0 %';
  printingFrm.Show;
  if printingFrm.CanFocus then
    printingFrm.SetFocus;
end;

procedure TRejbrandTextEditor.EditorPrintEnd(Sender: TObject);
begin
  printingFrm.Hide;
  TabList.Enabled := true;
  EnableWindow(TabList.Handle, true);
  ActionList.State := asNormal;
end;

function TRejbrandTextEditor.EditorPrintProgress(Sender: TObject; CurStep,
  NumSteps: Integer): Boolean;
begin
  if not printingFrm.Visible then
    printingFrm.Show;

  printingFrm.stPrintProgress.Caption := FormatFloat('0.0', 100*CurStep/NumSteps) + ' %';
  result := not FDoAbortPrinting;
end;

procedure TRejbrandTextEditor.EditorSelChange(Sender: TObject);
var
  c: char;
begin
  if Editor.TextFile.HasSelection then
    if Editor.CaretPos.Y = Editor.SelEndPos.Y then
      StatusBar.Panels[STATUS_FILE_POSITION].Text :=
        Format('Line: %d  Cols: %d–%d  Len: %d',
          [Editor.CaretPos.Y + 1,
           min(Editor.CaretPos.X, Editor.SelEndPos.X) + 1,
           max(Editor.CaretPos.X, Editor.SelEndPos.X) + 1,
           Editor.SelLength])
    else
      StatusBar.Panels[STATUS_FILE_POSITION].Text :=
        Format('Lines: %d–%d  Len: %d',
          [min(Editor.CaretPos.Y, Editor.SelEndPos.Y) + 1,
           max(Editor.CaretPos.Y, Editor.SelEndPos.Y) + 1,
           Editor.SelLength])
  else
    StatusBar.Panels[STATUS_FILE_POSITION].Text :=
      Format('Line: %d  Col: %d  Chr: %d',
        [Editor.CaretPos.Y + 1, Editor.CaretPos.X + 1, Editor.SelStart + 1]);

  if not FKeyPressed then
  begin
    c := Editor.GetCharAtCaret;
    StatusBarCharacterInfo(c);
    CharacterInfo(c);
  end;

  FKeyPressed := false;
end;

procedure TRejbrandTextEditor.CharacterInfo(const AChar: char);
begin
  if Assigned(chrFrm) and chrFrm.Visible then
  begin
    chrFrm.eChr.Text := AChar;
    chrFrm.eChrName.Text := UCD.GetChrName(AChar);
    chrFrm.eChrBlock.Text := UCD.GetChrBlock(AChar);
    chrFrm.eCode.Text := UCD.GetChrCodepointStr(AChar);
  end;
end;

function TRejbrandTextEditor.HasImportantNotification: boolean;
begin
  result := Editor.HasNotificationMessage(TTextEditor.EN_DRAG_MOVE) or
    Editor.HasNotificationMessage(TTextEditor.EN_DRAG_COPY) or
    Editor.HasNotificationMessage(TTextEditor.EN_SCRIPT) or
    Editor.HasNotificationMessage(TTextEditor.EN_MULTICARET);
end;

procedure TRejbrandTextEditor.StatusBarCharacterInfo(c: Char);
begin
  if not HasImportantNotification then
    StatusBar.Panels[STATUS_MESSAGE].Text := UCD.GetChrCodepointStr(c) + ': ' + UCD.GetChrName(c);
end;

procedure TRejbrandTextEditor.StatusBarContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
  Handled := true;

  if (MousePos.X = -1) and (MousePos.Y = -1) then
    Exit;


  if InRange(MousePos.X,
    0,
    StatusBar.Panels[STATUS_FILE_POSITION].Width) then
  begin
    with StatusBar.ClientToScreen(MousePos) do
      StatusPosPopup.Popup(X, Y);
  end
  else if InRange(MousePos.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width + StatusBar.Panels[STATUS_MESSAGE].Width) then
  begin
    with StatusBar.ClientToScreen(MousePos) do
      StatusMessagePopup.Popup(X, Y);
  end;

end;

procedure TRejbrandTextEditor.StatusBarDblClick(Sender: TObject);
var
  p: TPoint;
begin
  if not GetCursorPos(p) then Exit;
  p := StatusBar.ScreenToClient(p);

  if InRange(p.X,
    0,
    StatusBar.Panels[STATUS_FILE_POSITION].Width) then
  begin
    aGoTo.Execute;
  end
  else if InRange(p.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width) then
  begin
    Editor.Overwrite := not Editor.Overwrite;
  end
  else if InRange(p.X,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width,
    StatusBar.Panels[STATUS_FILE_POSITION].Width + StatusBar.Panels[STATUS_OVERWRITE].Width + StatusBar.Panels[STATUS_MESSAGE].Width) then
  begin
    aStatusMsgCopy.Execute;
  end;

end;

procedure TRejbrandTextEditor.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  if Panel = StatusBar.Panels[STATUS_ZOOM_CONTROL] then
    ZoomControl.BoundsRect := Classes.Rect(Rect.Left, Rect.Top,
      Rect.Right - GetSizeGripSize, Rect.Bottom);
end;

function TRejbrandTextEditor.GetSettingsFileName: string;
begin
  result := GetDriveAccess + 'settings.ini';
end;

procedure TRejbrandTextEditor.NewBufferWithContents(const S: string);
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].NewFile;
  FTextFiles[high(FTextFiles)].PlainText := S;
  FTextFiles[high(FTextFiles)].GotoSOF;
  FTextFiles[high(FTextFiles)].AddUndoRecord(SUndoNewFile, UID_UNKNOWN);
  FTextFiles[high(FTextFiles)].FileModified := false;
  UpdateTabs;
  GotoFile(high(FTextFiles));
end;

procedure TRejbrandTextEditor.NewFile;
begin
  SetLength(FTextFiles, Length(FTextFiles) + 1);
  FTextFiles[high(FTextFiles)] := TTextFile.Create;
  FTextFiles[high(FTextFiles)].NewFileAndInitUndo;
  UpdateTabs;
  GotoFile(high(FTextFiles));
  if Editor.Visible and Editor.CanFocus then
    Editor.SetFocus;
end;

procedure TRejbrandTextEditor.DestroyWnd;
begin
  RevokeDragDrop(Handle);
  inherited;
end;

procedure TRejbrandTextEditor.DoFindSymbol(APascal: boolean);
var
  S: string;
begin
  pnSearch.Show;
  if TabList.Visible then
    TabList.Top := 0;
  if eFind.CanFocus then
  begin
    eFind.SelectAll;
    if Editor.TextFile.HasSelection then
      S := Editor.SelText
    else
      S := Editor.TextFile.GetWord(APascal);
    if eFind.Text = S then
      eFind.Text := ''
    else
      eFind.Text := S;
  end;
end;

procedure TRejbrandTextEditor.OpenMnuURL(Sender: TObject);
begin
  if Sender is TMenuItem then
    ShellExecute(Handle, 'open', PChar(TMenuItem(Sender).Hint), nil, nil, SW_SHOWNORMAL)
end;

procedure TRejbrandTextEditor.ShowSettingsDialog(DefaultTab: Integer);
begin
  with TsettingsFrm.Create(nil) do
    try
      case Editor.ScrollBehaviour of
        sbDefault:
          rbScrollDef.Checked := true;
        sbLine:
          rbScrollLine.Checked := true;
        sbPixel:
          rbScrollPixel.Checked := true;
      end;
      cbDefEffect.ItemIndex := ord(Editor.BitmapEffect);
      cbDisabledEffect.ItemIndex := ord(Editor.DisabledEffect);
      eXML.Text := FSynHighlightAssocs[SYN_XML];
      eHTML.Text := FSynHighlightAssocs[SYN_HTML];
      eCSS.Text := FSynHighlightAssocs[SYN_CSS];
      eMW.Text := FSynHighlightAssocs[SYN_MW];
      ePascal.Text := FSynHighlightAssocs[SYN_PAS];
      eAlgoSim.Text := FSynHighlightAssocs[SYN_AS];
      eINI.Text := FSynHighlightAssocs[SYN_INI];
      lbReadOnlyAssocs.Items.Delimiter := ',';
      lbReadOnlyAssocs.Items.DelimitedText := FReadOnlyAssocs;
      lbTrimAssocs.Items.Delimiter := ',';
      lbTrimAssocs.Items.DelimitedText := FTrimAssocs;
      pcSettings.TabIndex := DefaultTab;
      if ShowModal = mrOk then
      begin
        if rbScrollDef.Checked then
          Editor.ScrollBehaviour := sbDefault
        else if rbScrollLine.Checked then
          Editor.ScrollBehaviour := sbLine
        else if rbScrollPixel.Checked then
          Editor.ScrollBehaviour := sbPixel;
        Editor.BitmapEffect := TBitmapEffect(cbDefEffect.ItemIndex);
        Editor.DisabledEffect := TBitmapEffect(cbDisabledEffect.ItemIndex);
        FSynHighlightAssocs[SYN_XML] := eXML.Text;
        FSynHighlightAssocs[SYN_HTML] := eHTML.Text;
        FSynHighlightAssocs[SYN_CSS] := eCSS.Text;
        FSynHighlightAssocs[SYN_MW] := eMW.Text;
        FSynHighlightAssocs[SYN_PAS] := ePascal.Text;
        FSynHighlightAssocs[SYN_AS] := eAlgoSim.Text;
        FSynHighlightAssocs[SYN_INI] := eINI.Text;
        FReadOnlyAssocs := lbReadOnlyAssocs.Items.DelimitedText;
        FTrimAssocs := lbTrimAssocs.Items.DelimitedText;
        SaveSettingsToFile;
      end;
    finally
      Free;
    end;
end;

function TRejbrandTextEditor.GetSizeGripSize: integer;
begin
  if (WindowState = wsNormal) and StatusBar.SizeGrip then
    result := 16
  else
    result := 0;
end;

procedure TRejbrandTextEditor.EditorSimpleNotification(Sender: TObject; MsgID: Cardinal;
  const AStr: string);
begin
  StatusBar.Panels[STATUS_MESSAGE].Text := AStr;
end;

procedure TRejbrandTextEditor.EditorZoomChange(Sender: TObject);
begin
  ZoomControl.UpdateZoomLevelSilently(Editor.Zoom);
end;

procedure TRejbrandTextEditor.FormActivate(Sender: TObject);
begin
  if FAutoTip and FFirstActivate then
    aTipOfTheDay.Execute;
  FFirstActivate := false;
end;

procedure TRejbrandTextEditor.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveSettingsToFile;
end;

procedure TRejbrandTextEditor.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  i: Integer;
begin
  CanClose := true;
  for i := 0 to high(FTextFiles) do
    if FTextFiles[i].FileModified then
      if not QueryFileSave(i) then
      begin
        CanClose := false;
        break;
      end;
end;

procedure TRejbrandTextEditor.FormCreate(Sender: TObject);
var
  i: Integer;
  FileNames: TArray<string>;
begin

  OleInitialize(nil);

  {$IFDEF DEBUG}
  ReportMemoryLeaksOnShutdown := true;
  {$ENDIF}

  CreateMutex(nil, false, PChar(REJBRAND_MUTEX_RTE_RTEDITOR));

  // Tip of the Day, for example
  Randomize;

  // Fields
  FDisabledByModality := false;
  FFirstActivate := true;
  FKeyPressed := false;
  FFirstTimeChrDlg := true;

  // Create new file
  Editor.NewFile;

  // Make sure the client owns the files
  Editor.TextFileOwner := tfoApplication;

  // Initial text file created by editor control
  SetLength(FTextFiles, 1);
  FTextFiles[0] := Editor.TextFile;
  UpdateTabs;
  SetWindowCaption;

  // Load settings
  LoadSettingsFromFile;

  // Process command-line arguments
  try
    SetLength(FileNames, ParamCount);
    for i := 1 to ParamCount do
      FileNames[i - 1] := ParamStr(i);
    LoadFiles(FileNames);
  finally
    if Length(FTextFiles) > 1 then
      CloseFile(0);
  end;

  // Drop target
  DragAcceptFiles(Handle, true);

  Editor.LoadDefaultClasses;

  for i := 0 to ComponentCount - 1 do
    if Components[i] is TFormattingProcessor then
      Editor.RegisterFP(TFormattingProcessor(Components[i]));

end;

procedure TRejbrandTextEditor.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  for i := high(FTextFiles) downto 0 do
    FreeAndNil(FTextFiles[i]);
  SetLength(FTextFiles, 0);
  OleUninitialize;
end;

procedure TRejbrandTextEditor.FormShow(Sender: TObject);
begin
  ZoomControl.Parent := StatusBar;
end;

procedure TRejbrandTextEditor.UpdateTabs;
var
  i: Integer;
begin
  TabList.Items.BeginUpdate;
  try
    TabList.Items.Clear;
    for i := 0 to high(FTextFiles) do
    begin
      TabList.Items.Add(ExtractFileName(FTextFiles[i].FileName) + IfThen(FTextFiles[i].FileModified, ' *'));
      if Editor.TextFile = FTextFiles[i] then
        TabList.ActiveTab := i;
    end;
  finally
    TabList.Items.EndUpdate;
  end;
  TabList.Visible := TabList.Items.Count > 1;
end;

procedure TRejbrandTextEditor.WMCopyData(var Message: TWMCopyData);
var
  buf: string;
  p: PChar;
  FileNames: TArray<string>;
  TF: TTextFile;
  MS: TMemoryStream;
begin
  Message.Result := 0;
  try
    case Message.CopyDataStruct.dwData and not RTE_COPYDATA_FLAG_MASK of
      RTE_COPYDATA_FILEARRAY:
        begin
          if (Message.CopyDataStruct.cbData > 0) and (Message.CopyDataStruct.lpData <> nil) then
          begin
            if Application.ModalLevel > 0 then
              Exit;
            SetLength(buf, Message.CopyDataStruct.cbData);
            p := PChar(buf);
            CopyMemory(p, Message.CopyDataStruct.lpData, Message.CopyDataStruct.cbData);
            while p^ <> #0 do
            begin
              SetLength(FileNames, Length(FileNames) + 1);
              FileNames[high(FileNames)] := string(p);
              inc(p, FileNames[high(FileNames)].Length + 1);
            end;
            if Length(FileNames) > 0 then
              LoadFiles(FileNames)
            else
              NewFile;
            Message.Result := 1;
            if WindowState = wsMinimized then
              Application.Restore;
          end;
        end;
      RTE_COPYDATA_TEXTFILE:
        begin
          if (Message.CopyDataStruct.cbData > 0) and (Message.CopyDataStruct.lpData <> nil) then
          begin
            if Application.ModalLevel > 0 then
              Exit;
            MS := TMemoryStream.Create;
            try
              MS.WriteBuffer(Message.CopyDataStruct.lpData^, Message.CopyDataStruct.cbData);
              TF := TTextFile.Create;
              SetLength(FTextFiles, Length(FTextFiles) + 1);
              FTextFiles[high(FTextFiles)] := TF;
              MS.Position := 0;
              TF.LoadFromStream(MS);
              UpdateTabs;
              GotoFile(high(FTextFiles));
            finally
              MS.Free;
            end;
            if Message.CopyDataStruct.dwData and RTE_COPYDATA_FLAG_CLOSEDUMMY <> 0 then
              CloseFile(0);
            Message.Result := 1;
            if WindowState = wsMinimized then
              Application.Restore;
          end;
        end;
    end;
  except
    Message.Result := 0;
  end;
end;

procedure TRejbrandTextEditor.WMDropFiles(var Message: TWMDropFiles);
var
  count: integer;
  i: Integer;
  FileName: array[0..MAX_PATH] of Char;
  FileNames: TArray<string>;
begin

  inherited;

  try
    count := DragQueryFile(Message.Drop, $FFFFFFFF, nil, 0);
    SetLength(FileNames, count);
    for i := 0 to Count - 1 do
      if DragQueryFile(Message.Drop, i, FileName, MAX_PATH) > 0 then
        FileNames[i] := FileName;
    LoadFiles(FileNames);
  finally
    DragFinish(Message.Drop);
  end;

  Message.Result := 0;

end;

procedure TRejbrandTextEditor.WMExitMenuLoop(var Message: TWMExitMenuLoop);
begin
  inherited;
  Editor.EditorCommand(EDITOR_COMMAND_UPDATE_SCROLL_MODE);
end;

procedure TRejbrandTextEditor.WMQueryPrevInst(var Message: TMessage);
begin
  if Application.ModalLevel = 0 then
    Message.Result := PREVINST_READY
  else
    Message.Result := PREVINST_NOTAVAIL;
end;

procedure TRejbrandTextEditor.ZoomControlChange(Sender: TObject);
begin
  Editor.Zoom := ZoomControl.ZoomLevel;
end;

function TRejbrandTextEditor.GetLastNotification: string;
begin
  if Editor.NotificationCount > 0 then
    result := Editor.NotificationStr[Editor.Notifications[Editor.NotificationCount - 1]]
  else
    result := '';
end;

procedure TRejbrandTextEditor.GotoFile(FileIndex: integer);
begin

  if not InRange(FileIndex, 0, high(FTextFiles)) then
    raise Exception.CreateFmt('Cannot go to non-existing file %d.', [FileIndex]);

  Editor.TextFile := FTextFiles[FileIndex];
  TabList.ActiveTab := FileIndex;
  SetWindowCaption;
  stNumMatches.Caption := '';
  stNumMatches.Hide;
  pnSearch.Hide;
  mnuEncoding.Enabled := not Editor.TextFile.StrictReadOnly;
  EditorSelChange(Self);
  StatusBar.Panels[STATUS_MESSAGE].Text := GetLastNotification;
  UpdateNotificationsWindow;

end;

procedure TRejbrandTextEditor.SetWindowCaption;
begin
  Caption := ExtractFileName(Editor.TextFile.FileName) + IfThen(Editor.TextFile.FileModified, ' *');
end;

procedure TRejbrandTextEditor.TabListChange(Sender: TObject);
begin
  GotoFile(TabList.ActiveTab);
end;

procedure TRejbrandTextEditor.TabListExit(Sender: TObject);
begin
  TabList.Visible := TabList.Items.Count > 1;
end;

procedure TRejbrandTextEditor.TabListMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbMiddle then
    CloseFile(ActiveFileIndex);
end;

procedure TRejbrandTextEditor.TabListTabCanInsert(Sender: TObject;
  const Data: pointer; const Len: UInt64; InsertionPos: Integer;
  var CanInsert: Boolean);
const
  BUFSIZE_CHRS = 1024*1024;
  BUFSIZE_BYTES = BUFSIZE_CHRS * sizeof(char);
var
  i: integer;
  NewTF: TTextFile;
begin

  InsertionPos := EnsureRange(InsertionPos, 0, Length(FTextFiles));

  CanInsert := true;
  NewTF := nil;
  try
    NewTF := TTextFile.Create;
    NewTF.LoadFromBuffer(Data, Len);
  except
    FreeAndNil(NewTF);
    CanInsert := false;
  end;

  if CanInsert then
  begin
    SetLength(FTextFiles, Length(FTextFiles) + 1);
    for i := high(FTextFiles) downto InsertionPos + 1 do
      FTextFiles[i] := FTextFiles[i - 1];
    FTextFiles[InsertionPos] := NewTF;
  end;

end;

procedure TRejbrandTextEditor.TabListTabCanSendAway(Sender: TObject;
  TabIndex: Integer; var Data: pointer; var Len: UInt64;
  var CanSend: Boolean);
begin
  CanSend := InRange(TabIndex, 0, high(FTextFiles));
  try
    Editor.PushEditorState;
    FTextFiles[TabIndex].CreateDataStream(Data, Len);
  except
    CanSend := false;
  end;
end;

procedure TRejbrandTextEditor.TabListTabInserted(Sender: TObject;
  const Data: pointer; const Len: UInt64; InsertionPos: Integer);
begin
  GotoFile(InsertionPos);
end;

procedure TRejbrandTextEditor.TabListTabMoved(Sender: TObject; TabIndex,
  InsertionPos: Integer);
var
  NewArray: TArray<TTextFile>;
begin

  if Length(FTextFiles) = 0 then
    Exit;

  if not InRange(TabIndex, low(FTextFiles), high(FTextFiles)) then
    raise Exception.Create('Invalid tab index reported in tab reorder operation.');

  if not InRange(InsertionPos, low(FTextFiles), Length(FTextFiles)) then
    raise Exception.Create('Invalid insertion pos reported in tab reorder operation.');

  if (InsertionPos = TabIndex) or (InsertionPos = TabIndex + 1) then
    Exit;

  SetLength(NewArray, Length(FTextFiles));

  if InsertionPos < TabIndex then
  begin
    Move(FTextFiles[0], NewArray[0], InsertionPos * sizeof(TTextFile));
    NewArray[InsertionPos] := FTextFiles[TabIndex];
    Move(FTextFiles[InsertionPos], NewArray[InsertionPos + 1], (TabIndex - InsertionPos) * sizeof(TTextFile));
    if TabIndex < high(FTextFiles) then
      Move(FTextFiles[TabIndex + 1], NewArray[TabIndex + 1], (high(FTextFiles) - TabIndex) * sizeof(TTextFile));
  end
  else {InsertionPos > TabIndex + 1}
  begin
    Move(FTextFiles[0], NewArray[0], TabIndex * sizeof(TTextFile));
    Move(FTextFiles[TabIndex + 1], NewArray[TabIndex], (InsertionPos - TabIndex - 1) * sizeof(TTextFile));
    NewArray[InsertionPos - 1] := FTextFiles[TabIndex];
    if InsertionPos < Length(FTextFiles) then
      Move(FTextFiles[InsertionPos], NewArray[InsertionPos], (Length(FTextFiles) - InsertionPos) * sizeof(TTextFile));
  end;

  FTextFiles := NewArray;

end;

procedure TRejbrandTextEditor.TabListTabSentAway(Sender: TObject;
  TabIndex: Integer);
begin

  if not InRange(TabIndex, low(FTextFiles), high(FTextFiles)) then
    raise Exception.Create('Invalid tab index reported in tab detach notification.');

  FTextFiles[TabIndex].FileModified := false;

  CloseFile(TabIndex);

end;

function TRejbrandTextEditor.SaveFile(FileIndex: integer): boolean;
var
  TF: TTextFile;
begin

  if not InRange(FileIndex, 0, high(FTextFiles)) then
    raise Exception.CreateFmt('Cannot save non-existing file %d.', [FileIndex]);

  TF := FTextFiles[FileIndex];
  if FileExists(TF.FileName) then
  begin
    try
      TF.SaveToFile(TF.FileName, GetTrimRight(TF.FileName));
      result := true;
    except
      on E: Exception do
      begin
        ShowErrorMessage(Format('An error occurred trying to save file "%s".'#13#10 + E.Message, [ExtractFileName(TF.FileName)]));
        result := false;
      end;
    end;
    UpdateTabs;
    SetWindowCaption;
  end
  else
    result := SaveFileAs(FileIndex);

end;

const
  CTL_ENCODING = 10;
  CTL_CB_ENCODING = 100;
  CTL_CB_ENCODING_UTF8 = 101;
  CTL_CB_ENCODING_UTF16LE = 102;
  CTL_CB_ENCODING_UTF16BE = 103;
  CTL_CB_ENCODING_UTF32LE = 104;
  CTL_CB_ENCODING_UTF32BE = 105;
  CTL_CB_ENCODING_ASCII = 106;
  CTL_CB_ENCODING_ANSI = 107;

  CTL_LINEBREAK = 20;
  CTL_CB_BOM = 200;
  CTL_CB_LINEBREAK = 300;
  CTL_CB_LINEBREAK_CRLF = 301;
  CTL_CB_LINEBREAK_LF = 302;

procedure TRejbrandTextEditor.SaveAsDialogExecute(Sender: TObject);
var
  FDC: IFileDialogCustomize;
begin

  if (Sender is TFileSaveDialog) and
    (TFileSaveDialog(Sender).Dialog.QueryInterface(IID_IFileDialogCustomize, FDC) = S_OK) then
  begin

    FDC.StartVisualGroup(CTL_ENCODING, 'Encoding:');
    if FDC.AddComboBox(CTL_CB_ENCODING) = S_OK then
    begin

      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF8, 'UTF-8');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF16LE, 'UTF-16 LE');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF16BE, 'UTF-16 BE');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF32LE, 'UTF-32 LE');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF32BE, 'UTF-32 BE');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_ASCII, 'ASCII');
      FDC.AddControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_ANSI, '8-bit extended ASCII');

      case Editor.TextFile.Encoding.TextEncoding of
        teASCII:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_ASCII);
        teWindows8bitCodepage:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_ANSI);
        teUTF8:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF8);
        teUTF16LE:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF16LE);
        teUTF16BE:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF16BE);
        teUTF32LE:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF32LE);
        teUTF32BE:
          FDC.SetSelectedControlItem(CTL_CB_ENCODING, CTL_CB_ENCODING_UTF32BE);
      end;

    end;
    FDC.AddCheckButton(CTL_CB_BOM, 'Byte-order mark', Editor.TextFile.Encoding.MagicWord);
    FDC.EndVisualGroup;

    FDC.StartVisualGroup(CTL_LINEBREAK, 'Line-break style:');
    if FDC.AddComboBox(CTL_CB_LINEBREAK) = S_OK then
    begin

      FDC.AddControlItem(CTL_CB_LINEBREAK, CTL_CB_LINEBREAK_CRLF, 'CR+LF');
      FDC.AddControlItem(CTL_CB_LINEBREAK, CTL_CB_LINEBREAK_LF, 'LF only');

      case Editor.TextFile.Encoding.LineBreakType of
        lbtCRLF:
          FDC.SetSelectedControlItem(CTL_CB_LINEBREAK, CTL_CB_LINEBREAK_CRLF);
        lbtLF:
          FDC.SetSelectedControlItem(CTL_CB_LINEBREAK, CTL_CB_LINEBREAK_LF);
      end;

    end;
    FDC.EndVisualGroup;

  end;

end;

procedure TRejbrandTextEditor.SaveAsDialogOnOKClick(Sender: TObject; var CanClose: boolean);
var
  FDC: IFileDialogCustomize;
  ItemID: cardinal;
  IsChecked: LongBool;
begin

  if (Sender is TFileSaveDialog) and
    (TFileSaveDialog(Sender).Dialog.QueryInterface(IID_IFileDialogCustomize, FDC) = S_OK) then
  begin

    if FDC.GetSelectedControlItem(CTL_CB_ENCODING, ItemID) = S_OK then
    begin
      case ItemID of
        CTL_CB_ENCODING_UTF8:
          Editor.TextFile.Encoding.SetEncoding(teUTF8);
        CTL_CB_ENCODING_UTF16LE:
          Editor.TextFile.Encoding.SetEncoding(teUTF16LE);
        CTL_CB_ENCODING_UTF16BE:
          Editor.TextFile.Encoding.SetEncoding(teUTF16BE);
        CTL_CB_ENCODING_UTF32LE:
          Editor.TextFile.Encoding.SetEncoding(teUTF32LE);
        CTL_CB_ENCODING_UTF32BE:
          Editor.TextFile.Encoding.SetEncoding(teUTF32BE);
        CTL_CB_ENCODING_ASCII:
          Editor.TextFile.Encoding.SetEncoding(teASCII);
        CTL_CB_ENCODING_ANSI:
          Editor.TextFile.Encoding.SetEncoding(teWindows8bitCodepage);
      end;
    end;

    if FDC.GetCheckButtonState(CTL_CB_BOM, IsChecked) = S_OK then
      Editor.TextFile.Encoding.SetMagicWord(IsChecked);

    if FDC.GetSelectedControlItem(CTL_CB_LINEBREAK, ItemID) = S_OK then
    begin
      case ItemID of
        CTL_CB_LINEBREAK_CRLF:
          Editor.TextFile.Encoding.SetLineBreakType(lbtCRLF);
        CTL_CB_LINEBREAK_LF:
          Editor.TextFile.Encoding.SetLineBreakType(lbtLF);
      end;
    end;

  end;

end;

function TRejbrandTextEditor.SaveFileAs(FileIndex: integer): boolean;
var
  TF: TTextFile;
  EFD, EFN: string;
  ExecRes: boolean;
begin

  if not InRange(FileIndex, 0, high(FTextFiles)) then
    raise Exception.CreateFmt('Cannot save non-existing file %d.', [FileIndex]);

  TF := FTextFiles[FileIndex];
  result := false;
  if ActiveFileIndex <> FileIndex then
    GotoFile(FileIndex);


  if TOSVersion.Check(6, 0) then
  begin

    with TFileSaveDialog.Create(nil) do
      try

        Options := [fdoOverWritePrompt, fdoPathMustExist];
        EFD := ExtractFileDir(TF.FileName);
        if DirectoryExists(EFD) then
          DefaultFolder := EFD;
        EFN := ExtractFileName(TF.FileName);
        if (EFN = '') or StartsText('New file', EFN) then
          FileName := GetInitialFileName(TF)
        else
          FileName := EFN;
        with FileTypes.Add do
        begin
          DisplayName := 'All files';
          FileMask := '*.*';
        end;

        OnExecute := SaveAsDialogExecute;
        OnFileOkClick := SaveAsDialogOnOKClick;

        Application.ModalStarted;
        try
          ExecRes := Execute;
        finally
          Application.ModalFinished;
        end;

        if ExecRes then
        begin
          try
            TF.SaveToFile(FileName, GetTrimRight(TF.FileName));
            result := true;
          except
            on E: Exception do
            begin
              ShowErrorMessage(Format('An error occurred trying to save file "%s".'#13#10 + E.Message, [ExtractFileName(TF.FileName)]));
              result := false;
            end;
          end;
          UpdateTabs;
          SetWindowCaption;
          ApplyAssocFormattingProcessor;
        end;

      finally
        Free;
      end;

  end

  else
  begin

    with TSaveDialog.Create(nil) do
      try
        Options := [ofOverwritePrompt, ofPathMustExist];
        EFD := ExtractFileDir(TF.FileName);
        if DirectoryExists(EFD) then
          InitialDir := EFD;
        EFN := ExtractFileName(TF.FileName);
        if (EFN = '') or StartsText('New file', EFN) then
          FileName := GetInitialFileName(TF)
        else
          FileName := EFN;
        Filter := 'All files|*.*';

        Application.ModalStarted;
        try
          ExecRes := Execute;
        finally
          Application.ModalFinished;
        end;

        if ExecRes then
        begin
          try
            TF.SaveToFile(FileName, GetTrimRight(TF.FileName));
            result := true;
          except
            on E: Exception do
            begin
              ShowErrorMessage(Format('An error occurred trying to save file "%s".'#13#10 + E.Message, [ExtractFileName(TF.FileName)]));
              result := false;
            end;
          end;
          UpdateTabs;
          SetWindowCaption;
          ApplyAssocFormattingProcessor;
        end;
      finally
        Free;
      end;

  end;

end;

function TRejbrandTextEditor.GetInitialFileName(const ATextFile: TTextFile): string;
var
  i, j: Integer;
begin
  result := '';
  if not Assigned(ATextFile) then Exit;
  if ATextFile.LineCount = 0 then Exit;
  result := Copy(ATextFile.Lines[0], 1, 64);
  for i := Length(result) downto 1 do
    if CharInSet(result[i], ['<', '>', ':', '"', '/', '\', '|', '?', '*']) or (result[i] < ' ') then
      Delete(result, i, 1);
  result := Trim(result);
  j := 0;
  for i := Length(result) downto 1 do
    if not CharInSet(result[i], [' ', '.']) then
    begin
      j := i;
      break;
    end;
  SetLength(result, j);
  if Length(result) > 0 then
    result := result + '.txt';
end;

function TRejbrandTextEditor.GetTrimRight(const AFileName: TFileName): boolean;
begin
  result := ItemInList(ExtractFileExt(AFileName), FTrimAssocs);
end;

function TRejbrandTextEditor.QueryFileSave(FileIndex: integer): boolean;
var
  TF: TTextFile;
begin
  result := false;
  TF := FTextFiles[FileIndex];
  if not TF.FileModified then Exit(true);
  GotoFile(FileIndex);
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(TF.FileName);
        Text := 'Do you want to save the changes made to this text file?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Save';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Don''t save';
          ModalResult := mrNo;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              result := SaveFile(FileIndex);
            mrNo:
              result := true;
            mrCancel:
              result := false;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        PChar(Format('Do you want to save the changes made to "%s"?',
          [ExtractFileName(TF.FileName)])), PChar(Application.Title),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        result := SaveFile(FileIndex);
      ID_NO:
        result := true;
      ID_CANCEL:
        result := false;
    end;
end;

function TRejbrandTextEditor.CloseFile(FileIndex: integer; CloseApp: boolean = true): boolean;
var
  TF: TTextFile;
  i: Integer;
begin

  if not InRange(FileIndex, 0, high(FTextFiles)) then
    raise Exception.CreateFmt('Cannot close non-existing file %d.', [FileIndex]);

  TF := FTextFiles[FileIndex];

  result := (not TF.FileModified) or QueryFileSave(FileIndex);

  if not result then Exit;


  if (Length(FTextFiles) = 1) and not CloseApp then
  begin
    // Simply replace current file (discard any changes) with a new one
    aNew.Execute;
    FTextFiles[0] := FTextFiles[1];
    SetLength(FTextFiles, 1);
    TF.Free;
    UpdateTabs;
    if Visible and Editor.CanFocus then
      Editor.SetFocus;
    Exit;
  end;


  if FileIndex = ActiveFileIndex then
    if FileIndex < high(FTextFiles) then
      GotoFile(FileIndex + 1)
    else if FileIndex > 0 then
      GotoFile(FileIndex - 1)
    else
      Editor.TextFile := nil;

  for i := FileIndex to high(FTextFiles) - 1 do
    FTextFiles[i] := FTextFiles[i + 1];

  SetLength(FTextFiles, Length(FTextFiles) - 1);

  TF.Free;

  if Length(FTextFiles) > 0 then
    UpdateTabs
  else
    Close;

  if not TabList.Visible then
    if Visible and Editor.CanFocus then
      Editor.SetFocus;

end;

procedure TRejbrandTextEditor.CreateWnd;
begin
  inherited;
  OleCheck(RegisterDragDrop(Handle, Self));
end;

procedure TRejbrandTextEditor.eFindChange(Sender: TObject);
begin
  DoInstantSearch;
end;

procedure TRejbrandTextEditor.eFindKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = chr(VK_RETURN) then
  begin
    DoInstantSearch;
    if (GetKeyState(VK_SHIFT) shr 16) <> 0 then
      aFindPrev.Execute
    else
      aFindNext.Execute;
    Key := #0;
  end;
  if Key = chr(VK_ESCAPE) then
  begin
    pnSearch.Hide;
    Key := #0;
    if Editor.CanFocus then
      Editor.SetFocus;
  end;
end;

procedure TRejbrandTextEditor.aCompareExecute(Sender: TObject);
var
  i: integer;
begin

  with TcompareFrm.Create(Self) do
    try

      cbFirst.Items.BeginUpdate;
      try
        cbFirst.Items.Clear;
        for i := 0 to high(FTextFiles) do
          cbFirst.Items.Add(ExtractFileName(FTextFiles[i].FileName))
      finally
        cbFirst.Items.EndUpdate;
      end;

      cbSecond.Items.Assign(cbFirst.Items);

      cbFirst.ItemIndex := TabList.ActiveTab;
      if TabList.ActiveTab < TabList.Items.Count - 1 then
        cbSecond.ItemIndex := TabList.ActiveTab + 1
      else if TabList.ActiveTab > 0 then
        cbSecond.ItemIndex := TabList.ActiveTab - 1;

      ComboBoxChanged(Sender);

      if ShowModal = mrOk then
        CompareBuffers(cbFirst.ItemIndex, cbSecond.ItemIndex);

    finally
      Free;
    end;

end;

procedure TRejbrandTextEditor.CompareBuffers(ALeftIndex, ARightIndex: integer);
var
  left, right: TTextFile;
  i: integer;
begin

  if not InRange(ALeftIndex, 0, High(FTextFiles)) then
    Exit;

  if not InRange(ARightIndex, 0, High(FTextFiles)) then
    Exit;

  if ALeftIndex = ARightIndex then
    Exit;

  left := FTextFiles[ALeftIndex];
  right := FTextFiles[ARightIndex];

  for i := 0 to Min(left.LineCount, right.LineCount) - 1 do
    if left.Lines[i] <> right.Lines[i] then
    begin
      GotoFile(ALeftIndex);
      Editor.SelectLine(i);
      MessageBox(
        Handle,
        PChar(Format('The buffers are not identical. They first differ at line %d.', [i + 1])),
        PChar(Application.Title),
        MB_ICONINFORMATION or MB_OK);
      Exit;
    end;

  if left.LineCount <> right.LineCount then
  begin
    if left.LineCount > right.LineCount then
    begin
      GotoFile(ALeftIndex);
      Editor.SelectLine(right.LineCount);
    end;
    if right.LineCount > left.LineCount then
    begin
      GotoFile(ARightIndex);
      Editor.SelectLine(left.LineCount);
    end;
    MessageBox(
        Handle,
        PChar('The buffers are not identical because one of them contains additional lines.'),
        PChar(Application.Title),
        MB_ICONINFORMATION or MB_OK);
    Exit;
  end;

  GotoFile(ALeftIndex);
  MessageBox(
      Handle,
      PChar('The buffers are identical.'),
      PChar(Application.Title),
      MB_ICONINFORMATION or MB_OK);

end;

procedure TRejbrandTextEditor.aCopyExecute(Sender: TObject);
var
  CP: TPoint;
begin
  if Editor.Focused then
  begin
    if Editor.TextFile.HasSelection then
      Editor.CopyToClipboard
    else if not Editor.GetWord.IsEmpty then
    begin
      CP := Editor.CaretPos;
      Editor.SelectWord;
      Editor.CopyToClipboard;
      Sleep(250);
      Editor.CaretPos := CP;
    end
  end
  else if Assigned(Screen.ActiveControl) then
    Screen.ActiveControl.Perform(WM_COPY, 0, 0);
end;

procedure TRejbrandTextEditor.aCopyFileNameExecute(Sender: TObject);
begin
  Clipboard.AsText := Editor.TextFile.FileName;
end;

procedure TRejbrandTextEditor.aCopyUpdate(Sender: TObject);
begin
  aCopy.Enabled :=
    (Editor.Focused and (Editor.TextFile.HasSelection or not Editor.GetWord.IsEmpty))
    or
    ((Screen.ActiveControl is TCustomEdit) and (TCustomEdit(Screen.ActiveControl).SelLength <> 0));
end;

function TRejbrandTextEditor.ActiveFileIndex: integer;
begin
  result := TabList.ActiveTab;
end;

procedure TRejbrandTextEditor.ShowErrorMessage(const Str: string);
begin
  MessageBox(Handle, PChar(Str), PChar(Application.Title), MB_ICONERROR or MB_OK);
end;

procedure TRejbrandTextEditor.StatusBarResize(Sender: TObject);
begin
  StatusBar.Panels[STATUS_MESSAGE].Width := StatusBar.Width -
    StatusBar.Panels[STATUS_FILE_POSITION].Width -
    StatusBar.Panels[STATUS_OVERWRITE].Width -
    StatusBar.Panels[STATUS_ZOOM_CONTROL].Width;
end;

function TRejbrandTextEditor.SelectColor(var AColor: TColor): boolean;
begin
  with ColorDialog.TColorDialog.Create(nil) do
    try
      Color := AColor;
      result := Execute;
      if result then
        AColor := Color;
    finally
      Free;
    end;
end;

const
  SEV = 'Editor appearance';
  SEB = 'Editor behaviour';
  APPS = 'Application settings';
  ASS = 'Associations';

procedure TRejbrandTextEditor.SaveSettingsToFile;
begin
  with TIniFile.Create(GetSettingsFileName) do
    try
      WriteInteger(SEV, 'Bitmap effect', ord(Editor.BitmapEffect));
      WriteInteger(SEV, 'Disabled effect', ord(Editor.DisabledEffect));

      WriteString(SEV, 'Font', Editor.Font.Name);
      WriteInteger(SEV, 'Font size', Editor.Font.Size);
      WriteInteger(SEV, 'Background color', Editor.BackgroundColor);
      WriteInteger(SEV, 'Foreground color', Editor.ForegroundColor);
      WriteInteger(SEV, 'Selection background color', Editor.SelBackgroundColor);
      WriteInteger(SEV, 'Selection foreground color', Editor.SelForegroundColor);
      WriteInteger(SEV, 'Find highlight background color', Editor.FindBackgroundColor);
      WriteInteger(SEV, 'Find highlight foreground color', Editor.FindForegroundColor);
      WriteInteger(SEV, 'Row highlight color', Editor.LineHighlightColor);
      WriteInteger(SEV, 'Bracket highlight color', Editor.BracketHighlightColor);
      WriteInteger(SEV, 'Ruler color', Editor.RulerColor);
//      WriteInteger(SEV, 'Ruler width', Editor.RulerWidth);
      WriteBool(SEV, 'Ruler visible', Editor.RulerVisible);
      WriteString(SEV, 'Ruler font', Editor.RulerFont.Name);
      WriteInteger(SEV, 'Ruler font size', Editor.RulerFont.Size);
      WriteInteger(SEV, 'Ruler font color', Editor.RulerFont.Color);
//      WriteInteger(SEV, 'Margin left', Editor.MarginLeft);
//      WriteInteger(SEV, 'Margin top', Editor.MarginTop);
//      WriteInteger(SEV, 'Margin right', Editor.MarginRight);
//      WriteInteger(SEV, 'Margin bottom', Editor.MarginBottom);
      WriteBool(SEV, 'Row highlight', Editor.LineHighlight);
      WriteBool(SEV, 'Use system colors', Editor.UseSystemColors);
      WriteBool(SEV, 'Show hidden characters', Editor.ShowHiddenCharacters);

      WriteBool(SEB, 'Caret beyond EOL', Editor.CaretAfterEOL);
      WriteBool(SEB, 'Auto indent', Editor.AutoIndent);
      WriteBool(SEB, 'Auto replace', Editor.AutoReplace);
      WriteBool(SEB, 'Bracket highlight', Editor.MatchBrackets);
      WriteBool(SEB, 'Multi char select', Editor.MultiCharSelect);
      WriteInteger(SEB, 'Tab length', Editor.TabLength);
      WriteInteger(SEB, 'Scroll behaviour', ord(Editor.ScrollBehaviour));

      WriteBool(APPS, 'Status bar', StatusBar.Visible);
      WriteBool(APPS, 'Tip of the day', FAutoTip);

      WriteString(ASS, 'XML', FSynHighlightAssocs[SYN_XML]);
      WriteString(ASS, 'HTML', FSynHighlightAssocs[SYN_HTML]);
      WriteString(ASS, 'CSS', FSynHighlightAssocs[SYN_CSS]);
      WriteString(ASS, 'MediaWiki', FSynHighlightAssocs[SYN_MW]);
      WriteString(ASS, 'Pascal', FSynHighlightAssocs[SYN_PAS]);
      WriteString(ASS, 'AlgoSim', FSynHighlightAssocs[SYN_AS]);
      WriteString(ASS, 'INI', FSynHighlightAssocs[SYN_INI]);

      WriteString(ASS, 'Read only', FReadOnlyAssocs);
      WriteString(ASS, 'Trim', FTrimAssocs);
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.LoadSettingsFromFile;
begin
  with TIniFile.Create(GetSettingsFileName) do
    try
      Editor.BitmapEffect := TBitmapEffect(ReadInteger(SEV, 'Bitmap effect', 0));
      Editor.DisabledEffect := TBitmapEffect(ReadInteger(SEV, 'Disabled effect', 1));

      Editor.Font.Name := ReadString(SEV, 'Font', 'DejaVu Sans Mono');
      Editor.Font.Size := ReadInteger(SEV, 'Font size', 10);
      Editor.BackgroundColor := ReadInteger(SEV, 'Background color', clWhite);
      Editor.ForegroundColor := ReadInteger(SEV, 'Foreground color', clBlack);
      Editor.SelBackgroundColor := ReadInteger(SEV, 'Selection background color', clBlack);
      Editor.SelForegroundColor := ReadInteger(SEV, 'Selection foreground color', clWhite);
      Editor.FindBackgroundColor := ReadInteger(SEV, 'Find highlight background color', clYellow);
      Editor.FindForegroundColor := ReadInteger(SEV, 'Find highlight foreground color', clBlack);
      Editor.LineHighlightColor := ReadInteger(SEV, 'Row highlight color', TTextEditor.DEFAULT_LINE_HIGHLIGHT_COLOR);
      Editor.BracketHighlightColor := ReadInteger(SEV, 'Bracket highlight color', TTextEditor.DEFAULT_BRACKET_HIGHLIGHT_COLOR);
      Editor.RulerColor := ReadInteger(SEV, 'Ruler color', clDefault);
//      Editor.RulerWidth := ReadInteger(SEV, 'Ruler width', TTextEditor.DEFAULT_RULER_WIDTH);
      Editor.RulerVisible := ReadBool(SEV, 'Ruler visible', true);
      Editor.RulerFont.Name := ReadString(SEV, 'Ruler font', 'Segoe UI');
      Editor.RulerFont.Size := ReadInteger(SEV, 'Ruler font size', 8);
      Editor.RulerFont.Color := ReadInteger(SEV, 'Ruler font color', clWindowText);
//      Editor.MarginLeft := ReadInteger(SEV, 'Margin left', TTextEditor.DEFAULT_MARGIN_LEFT);
//      Editor.MarginTop := ReadInteger(SEV, 'Margin top', TTextEditor.DEFAULT_MARGIN_TOP);
//      Editor.MarginRight := ReadInteger(SEV, 'Margin right', TTextEditor.DEFAULT_MARGIN_RIGHT);
//      Editor.MarginBottom := ReadInteger(SEV, 'Margin bottom', TTextEditor.DEFAULT_MARGIN_BOTTOM);
      Editor.LineHighlight := ReadBool(SEV, 'Row highlight', true);
      Editor.UseSystemColors := ReadBool(SEV, 'Use system colors', true);
      Editor.ShowHiddenCharacters := ReadBool(SEV, 'Show hidden characters', false);

      Editor.CaretAfterEOL := ReadBool(SEB, 'Caret beyond EOL', true);
      Editor.AutoIndent := ReadBool(SEB, 'Auto indent', true);
      Editor.AutoReplace := ReadBool(SEB, 'Auto replace', true);
      Editor.MatchBrackets := ReadBool(SEB, 'Bracket highlight', true);
      Editor.MultiCharSelect := ReadBool(SEB, 'Multi char select', true);
      Editor.TabLength := ReadInteger(SEB, 'Tab length', 2);
      Editor.ScrollBehaviour := TScrollBehaviour(ReadInteger(SEB, 'Scroll behaviour', ord(sbDefault)));
      if ReadBool(SEB, 'AlgoSim AutoToggle Behaviour', false) then
        Editor.EditorCommand(EDITOR_COMMAND_SET_AS_HYPHEN_ASTERISK_TOGGLE, 1);

      StatusBar.Visible := ReadBool(APPS, 'Status bar', true);
      FAutoTip := ReadBool(APPS, 'Tip of the day', false);

      FSynHighlightAssocs[SYN_XML] := ReadString(ASS, 'XML', DEFAULT_ASSOC_XML);
      FSynHighlightAssocs[SYN_HTML] := ReadString(ASS, 'HTML', DEFAULT_ASSOC_HTML);
      FSynHighlightAssocs[SYN_CSS] := ReadString(ASS, 'CSS', DEFAULT_ASSOC_CSS);
      FSynHighlightAssocs[SYN_MW] := ReadString(ASS, 'MediaWiki', DEFAULT_ASSOC_MW);
      FSynHighlightAssocs[SYN_PAS] := ReadString(ASS, 'Pascal', DEFAULT_ASSOC_PAS);
      FSynHighlightAssocs[SYN_AS] := ReadString(ASS, 'AlgoSim', DEFAULT_ASSOC_AS);
      FSynHighlightAssocs[SYN_INI] := ReadString(ASS, 'INI', DEFAULT_ASSOC_INI);

      FReadOnlyAssocs := ReadString(ASS, 'Read only', '');
      FTrimAssocs := ReadString(ASS, 'Trim', '');
    finally
      Free;
    end;
end;

procedure TRejbrandTextEditor.LoadSingleInstanceRTEFile(const AFileName: TFileName);
var
  i: Integer;
begin
  for i := 0 to high(FTextFiles) do
    if SameFileName(AFileName, FTextFiles[i].FileName) then
    begin
      GotoFile(i);
      Exit;
    end;

  LoadRTEFile(AFileName);
end;

procedure TRejbrandTextEditor.RestoreDefaultSettings;
var
  fn: TFileName;
begin
  fn := GetSettingsFileName;
  if FileExists(fn) then
    if not DeleteFile(fn) then
    begin
      ShowErrorMessage('An error occurred while trying to delete the current settings file. No settings will be changed right now.');
      Exit;
    end;

  LoadSettingsFromFile;
end;

procedure TRejbrandTextEditor.ApplicationEventsException(Sender: TObject; E: Exception);
begin
  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(self) do
      try
        Caption := 'Rejbrand Text Editor';
        Title := 'Program Error';
        CommonButtons := [tcbClose];
        MainIcon := tdiError;
        Text := 'Unfortunately, a program error has occurred in Rejbrand Text Editor.' + #13#10#13#10 + 'Rejbrand Text Editor is supposed to be a bug-free application, so the developer would very much appreciate if you reported this error by sending an e-mail to <a href="mailto:andreas@rejbrand.se">andreas@rejbrand.se</a>.'+#13#10#13#10+'In the e-mail, please describe in detail how to reproduce this error. Also include your operating system version and the technical information in the footer of this dialog box.';
        FooterText := E.ClassName + ': ' + E.Message;
        Flags := [tfEnableHyperlinks, tfExpandFooterArea];
        OnHyperlinkClicked := TaskDialogHyperlinkClicked;
        ExecuteModally;
      finally
        Free;
      end
  else
    MessageBox(Handle,
      'Unfortunately, a program error has occurred in Rejbrand Text Editor.' +
        #13#10#13#10 + 'Rejbrand Text Editor is supposed to be a bug-free application, so the developer would very much appreciate if you reported this error by sending an e-mail to andreas@rejbrand.se.'+#13#10#13#10+'In the e-mail, please describe in detail how to reproduce this error. Also include your operating system version and the technical information in the footer of this dialog box.',
      'Rejbrand Text Editor', MB_ICONERROR or MB_OK);
end;

procedure TRejbrandTextEditor.ApplicationEventsHint(Sender: TObject);
begin
  if Application.Hint <> '' then
  begin
    StatusBar.SimplePanel := true;
    StatusBar.SimpleText := Application.Hint;
  end
  else
  begin
    StatusBar.SimplePanel := false;
    StatusBar.SimpleText := '';
  end;
end;

procedure TRejbrandTextEditor.ApplicationEventsModalBegin(Sender: TObject);
begin
  if Editor.DisabledEffect <> beNone then
    if Editor.Enabled then
    begin
      FOldDefaultEffect := Editor.BitmapEffect;
      Editor.BitmapEffect := Editor.DisabledEffect;
      FDisabledByModality := true;
    end;
end;

procedure TRejbrandTextEditor.ApplicationEventsModalEnd(Sender: TObject);
begin
  if Editor.DisabledEffect <> beNone then
    if FDisabledByModality then
    begin
      Editor.BitmapEffect := FOldDefaultEffect;
      FDisabledByModality := false;
    end;
end;

procedure TRejbrandTextEditor.ApplicationEventsSettingChange(Sender: TObject;
  Flag: Integer; const Section: string; var Result: Integer);
begin
  Editor.EditorCommand(EDITOR_COMMAND_UPDATE_SPI);
end;

procedure TRejbrandTextEditor.ApplyAssocFormattingProcessor;
var
  ext: string;
begin
  ext := ExtractFileExt(Editor.TextFile.FileName);
  if ext = '' then Exit;
  if ItemInList(ext, FSynHighlightAssocs[SYN_XML]) then
    Editor.FormattingProcessor := XMLFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_HTML]) then
    Editor.FormattingProcessor := HTMLFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_CSS]) then
    Editor.FormattingProcessor := CSSFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_MW]) then
    Editor.FormattingProcessor := MediaWikiFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_PAS]) then
    Editor.FormattingProcessor := PascalFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_AS]) then
    Editor.FormattingProcessor := AlgoSimFormattingProcessor1
  else if ItemInList(ext, FSynHighlightAssocs[SYN_INI]) then
    Editor.FormattingProcessor := INIFormattingProcessor1
  else
    Editor.FormattingProcessor := nil;
end;

procedure TRejbrandTextEditor.ApplyAssocReadOnlyMode;
var
  ext: string;
begin
  ext := ExtractFileExt(Editor.TextFile.FileName);
  if ext = '' then Exit;
  if ItemInList(ext, FReadOnlyAssocs) then
    Editor.EditMode := emReadOnly
  else
    Editor.EditMode := emText;
end;

procedure TRejbrandTextEditor.EncodingMenuSelect;
begin
  if not Editor.TextFile.RecentlyOpened then Exit;

  if (Win32MajorVersion >= 6) and ThemeServices.ThemesEnabled then
    with TTaskDialog.Create(Self) do
      try
        Caption := Application.Title;
        Title := ExtractFileName(Editor.TextFile.FileName);
        Text := 'Do you want to reopen this file using the new encoding?';
        CommonButtons := [];
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Reopen';
          ModalResult := mrYes;
        end;
        with TTaskDialogButtonItem(Buttons.Add) do
        begin
          Caption := '&Cancel';
          ModalResult := mrCancel;
        end;
        MainIcon := tdiNone;
        if ExecuteModally then
          case ModalResult of
            mrYes:
              begin
                Screen.Cursor := crHourGlass;
                try
                  Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
                finally
                  Screen.Cursor := crDefault;
                end;
              end;
          end
      finally
        Free;
      end
  else
    case
      MessageBox(Handle,
        'Do you want to reopen this file using the new encoding?',
        PChar(ExtractFileName(Editor.TextFile.FileName)),
        MB_ICONQUESTION or MB_YESNOCANCEL) of
      ID_YES:
        begin
          Screen.Cursor := crHourGlass;
          try
            Editor.LoadFromFile(Editor.TextFile.FileName, Editor.TextFile.Encoding.GetVCLEncoding);
          finally
            Screen.Cursor := crDefault;
          end;
        end;
    end;

end;

procedure TRejbrandTextEditor.aBlockPasteExecute(Sender: TObject);
begin
  Editor.PasteFromClipboardAsBlock;
end;

procedure TRejbrandTextEditor.aBlockPasteUpdate(Sender: TObject);
begin
  aBlockPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
end;

{ TTaskDialogHelper }

function TTaskDialogHelper.ExecuteModally: boolean;
begin
  Application.ModalStarted;
  try
    result := Execute;
  finally
    Application.ModalFinished;
  end;
end;

end.
